#ifndef ANDORCOMPAT_H
#define ANDORCOMPAT_H

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,11)
#include <linux/config.h>
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)  
  #define AndorModuleParamInt(PARAM_VAR) MODULE_PARM(PARAM_VAR, "i")
#else
  #define AndorModuleParamInt(PARAM_VAR) module_param(PARAM_VAR, int, 0)
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,8)
  #define  ANDOR_PCI_FN_GET_DEVICE   pci_find_device
#else
  #define  ANDOR_PCI_FN_GET_DEVICE   pci_get_device
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,23)  
  #define  ANDOR_IRQ_PARAM_SHARED    SA_SHIRQ
  #define  ANDOR_IRQ_PARAM_DISABLED  SA_INTERRUPT
#else
  #define  ANDOR_IRQ_PARAM_SHARED    IRQF_SHARED 
  #define  ANDOR_IRQ_PARAM_DISABLED  IRQF_DISABLED
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,23)  
  #define ANDOR_IRQ_HANDLER_TYPECAST(type)     
#else
  #define ANDOR_IRQ_HANDLER_TYPECAST(type)    (type) 
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0)  
  #define AndorModuleParamLong(PARAM_VAR) MODULE_PARM(PARAM_VAR, "l")
#else
  #define AndorModuleParamLong(PARAM_VAR) module_param(PARAM_VAR, long, 0)
#endif

#endif
