#include "main.h"
#include "amcc.h"

int AndorPldMailboxRead(int iCardNo, ulong ulArg, ulong *pulData)
{
	long box;

	if(copy_from_user(pulData, (ulong *)ulArg, 2*sizeof(ulong)))
      return -EFAULT;

	box = pulData[0] - 4;

	if(box > PLD_IMB4 || box < PLD_IMB1)
    return -EINVAL;
    
	pulData[1] = readl((void*)gpAndorDev[iCardNo].Addrs[PLD_RRBA1].uiAddr + (box * 4));

  if(copy_to_user((ulong *) ulArg, pulData, 2*sizeof(ulong)))
      return -EFAULT;

	return 0;
}


int AndorPldMailboxWrite(int iCardNo, ulong ulArg, ulong *pulData)
{
  if(copy_from_user(pulData, (ulong *) ulArg, 2*sizeof(ulong)))
      return -EFAULT;

  if(pulData[0] > PLD_OMB4 || pulData[0] < PLD_OMB1)
    return -EINVAL;
  
  writel(pulData[1], (void*)gpAndorDev[iCardNo].Addrs[PLD_WRBA1].uiAddr + (pulData[0] * 4));
  
  return 0;
}


int AndorPldOpregRead(int iCardNo, ulong ulArg, ulong *pulData)
{
  if(copy_from_user(pulData, (ulong *) ulArg, 2*sizeof(ulong)))
      return -EFAULT;

  if(pulData[0] == AMCC_MBEF)
    pulData[1] = readl((void*)gpAndorDev[iCardNo].Addrs[PLD_RRBA1].uiAddr + (PLD_IMBEF * 4));
  else if (pulData[0] == AMCC_MBSR)
    pulData[1] = readl((void*)gpAndorDev[iCardNo].Addrs[PLD_RRBA1].uiAddr + (PLD_IMBSR * 4));
  else
    return 0;

  if(copy_to_user((ulong *) ulArg, pulData, 2*sizeof(ulong)))
      return -EFAULT;

  return 0;
}


int AndorPldOpregWrite(int iCardNo, ulong ulArg, ulong *pulData)
{
  if(copy_from_user(pulData, (ulong *) ulArg, 2*sizeof(ulong)))
    return -EFAULT;

  if(pulData[0] == AMCC_MBEF)
    writel(pulData[1], (void*)gpAndorDev[iCardNo].Addrs[PLD_WRBA1].uiAddr + (PLD_OMBEF * 4));
  else if(pulData[0] == AMCC_MBSR)
    writel(pulData[1], (void*)gpAndorDev[iCardNo].Addrs[PLD_WRBA1].uiAddr + (PLD_OMBSR * 4));
  else
    return 0;

  return 0;
}
