/************************************************************************/
/* bunker_clock.h							*/
/*                                                                      */
/* This version of code for 2.6 kernels non-rt linux.			*/
/************************************************************************/
/*                                                                      */
/*     Center for High Angular Resolution Astronomy                     */
/* Georgia State University, Atlanta GA 30303-3083, U.S.A.              */
/*                                                                      */
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu/~theo/theo.html                  */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar                                         */
/* Date   : Nov 2009                                                    */
/************************************************************************/

#ifndef __BUNKER_CLOCK__
#define __BUNKER_CLOCK__

/* Include files */

#include <sys/types.h>
#include <unistd.h>

/* Prototypes */

bool bunker_clock_open(void);
void bunker_clock_close(void);
int bunker_clock_reset(void);
int bunker_clock_stop(void);
int bunker_clock_start(void);
int bunker_clock_set(unsigned char arg);
int call_bunker_clock_reset(int argc, char **argv);
int call_bunker_clock_stop(int argc, char **argv);
int call_bunker_clock_start(int argc, char **argv);
int call_bunker_clock_set(int argc, char **argv);
int show_bunker_clockstruct(int argc, char **argv);
int sync_machine(int argc, char **argv);
int bunker_clock_start_message(struct smessage *mess);
int bunker_clock_stop_message(struct smessage *mess);
int bunker_clock_reset_gps_message(struct smessage *mess);
int bunker_clock_msync_message(struct smessage *mess);
void setup_standard_bunker_clock_messages(void);
void bunker_clock_date(int *year, int *month, int *day);

#endif
