/************************************************************************/
/* functs.c								*/
/*                                                                      */
/* Discription                                   	 		*/
/*	Sets up look up table array of user callable function modules.	*/
/*	This is the file to change (along with menus.ini) when		*/
/*	installing new user callable functions.				*/
/************************************************************************/
/*                                                                      */
/*                    CHARA ARRAY USER INTERFACE			*/
/*                 Based on the SUSI User Interface			*/
/*		In turn based on the CHIP User interface		*/
/*                                                                      */
/*            Center for High Angular Resolution Astronomy              */
/*              Mount Wilson Observatory, CA 91001, USA			*/
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu			                */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Tony Johnson & Theo ten Brummelaar                          */
/* Date   : Original Version 1990 - ported to Linux 1998                */
/************************************************************************/

#define FUNCTS
#include <charaui.h>
#undef FUNCTS
#include "../clock/clock.h"
#include "./bunker_clock.h"

int     report_time_next_second(int argc, char **argv);
int     report_time(int argc, char **argv);
int     test_signal_time(int argc, char **argv);

struct {                       
                char    *name;
                int     (*function)(int argc, char **argv);
        } functions[] = 

	{	{NULL,		NULL},

#include"../charaui/src/std_ui_functs.h"
#include"../clock/std_clock_functs.h"
#include"./std_bunker_clock_functs.h"

                {"rtns",     report_time_next_second},
                {"rt",     report_time},
                {"testsig",     test_signal_time},

		{NULL,		NULL}	};
