////////////////////////////////////////////////////////////////////////////////
//////++++++//////++//////++//////++++++//++//////++//++++++++//////////////////
//////++////++////++//////++////++////////++//////++//++////////////////////////
//////++//////++//++//////++//++//////////++++++++++//++++++////////////////////
//////++//////++//++//////++//++//////////++//////++//++////////////////////////
//////++////++////++//////++////++////////++//////++//++////////////////////////
//////++++++////////++++++////////++++++//++//////++//++++++++// Production ////
////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//      Ecrit par Duche.                                                      //
//      Contact: le_grand_duche@hotmail.com                                   //
//                                                                            //
//      Date de dernière modification : 01/01/2006                            //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
//  Moment.cpp  ////////////////////////////////////////////////////////////////

#include "moments.h"
#include <sys/timeb.h>

////////////////////////////////////////////////////////////////////////////////
//  DÉFINITIONS DES FONCTIONS DE LA CLASSE MOMENT  /////////////////////////////

int Moment::year()
{
	return Year;
}

int Moment::month()
{
	return Month;
}

int Moment::day()
{
	return Day;
}

int Moment::wday()
{
	return Wday;
}

int Moment::hour()
{
	return Hour;
}

int Moment::min()
{
	return Min;
}

int Moment::sec()
{
	return Sec;
}

int Moment::milli()
{
	return Milli;
}

int Moment::realValueTime()
{
	return RealValue.time;
}

int Moment::realValueMilliTm()
{
	return RealValue.millitm;
}

////////////////////////////////////////////////////////////////////////////////

void Moment::update()
{
	ftime(&RealValue);
	transf();
}

////////////////////////////////////////////////////////////////////////////////

bool Moment::operator < (const Moment& m)
{
	return (RealValue.time < m.RealValue.time)||((RealValue.time == m.RealValue.time)&&(RealValue.millitm < m.RealValue.millitm));
}

bool Moment::operator > (const Moment& m)
{
	return (RealValue.time > m.RealValue.time)||((RealValue.time == m.RealValue.time)&&(RealValue.millitm > m.RealValue.millitm));
}

bool Moment::operator <= (const Moment& m)
{
	return (RealValue.time < m.RealValue.time)||((RealValue.time == m.RealValue.time)&&(RealValue.millitm <= m.RealValue.millitm));
}

bool Moment::operator >= (const Moment& m)
{
	return (RealValue.time > m.RealValue.time)||((RealValue.time == m.RealValue.time)&&(RealValue.millitm >= m.RealValue.millitm));
}

Moment Moment::operator	+ (int n)
{
	Moment m;
	int p = (RealValue.millitm + n)%1000;
	int q = (RealValue.millitm + n)/1000;
	m.RealValue.millitm = p;
	m.RealValue.time = RealValue.time + q;
	m.transf();
	return m;
}

Moment Moment::operator - (int n)
{
	Moment m;
	int p = (RealValue.millitm + 1000-n%1000)%1000;
	int q = n/1000-(RealValue.millitm+1000-n%1000)/1000+1;
	m.RealValue.millitm = p;
	m.RealValue.time = RealValue.time - q;
	m.transf();
	return m;
}

double operator - (const Moment& m1,const Moment& m2)
{
	return (double)(1000*(m1.RealValue.time-m2.RealValue.time)+m1.RealValue.millitm-m2.RealValue.millitm);
}

void Moment::transf()
{
	Milli = RealValue.millitm;
	int nbr = RealValue.time;
	Sec = nbr%60;
	nbr /= 60;
	nbr -= RealValue.timezone;
	Min = nbr%60;
	nbr /= 60;
	Hour = nbr%24;
	nbr /= 24;
	Wday = (nbr+4)%7;
	int cycle400,cycle100,cycle4;
	cycle400 = (nbr+135140)/146097;
	nbr = (nbr+135140)%146097;
	if(nbr < 36525)
		cycle100 = 0;
	else
	{
		nbr--;
		cycle100 = nbr/36524;
		nbr %= 36524;
	}
	if(nbr < 1460)
		cycle4 = 0;
	else
	{
		nbr++;
		cycle4 = nbr/1461;
		nbr %= 1461;
	}
	int biss;
	if(nbr < 366)
	{
		Year = 1600+400*cycle400+100*cycle100+4*cycle4;
		biss = 1;
	}
	else
	{
		nbr--;
		Year = 1600+400*cycle400+100*cycle100+4*cycle4+nbr/365;
		nbr %= 365;
		biss = 0;
	}
	if(nbr >= 334+biss)
	{
		Month = 12;
		nbr -= 334+biss;
	}
	else if(nbr >= 304+biss)
	{
		Month = 11;
		nbr -= 304+biss;
	}
	else if(nbr >= 273+biss)
	{
		Month = 10;
		nbr -= 273+biss;
	}
	else if(nbr >= 243+biss)
	{
		Month = 9;
		nbr -= 243+biss;
	}
	else if(nbr >= 212+biss)
	{
		Month = 8;
		nbr -= 212+biss;
	}
	else if(nbr >= 181+biss)
	{
		Month = 7;
		nbr -= 181+biss;
	}
	else if(nbr >= 151+biss)
	{
		Month = 6;
		nbr -= 151+biss;
	}
	else if(nbr >= 120+biss)
	{
		Month = 5;
		nbr -= 120+biss;
	}
	else if(nbr >= 90+biss)
	{
		Month = 4;
		nbr -= 90+biss;
	}
	else if(nbr >= 59+biss)
	{
		Month = 3;
		nbr -= 59+biss;
	}
	else if(nbr >= 31)
	{
		Month = 2;
		nbr -= 31;
	}
	else
		Month = 1;
	Day = nbr;
	/*
	Algo de test si +1h ou pas à ajouter ? (selon hivers/été)
	je fais +0 pour pouvoir tester le code en heures d'hiver
	*/
}

////////////////////////////////////////////////////////////////////////////////
//  DÉFINITIONS ET FONCTIONS DE LA CLASSE CHRONO ///////////////////////////////

Chrono::Chrono(int q)
{
	Milli = new int[q];
	Sec = new int[q];
	Min = new int[q];
	Hour = new int[q];
	FirstStartValue = new Moment[q];
	EffectValue = new int[q];
	State = new int[q];
	Nbr = q;
}

Chrono::~Chrono()
{
	delete [] Milli;
	delete [] Sec;
	delete [] Min;
	delete [] Hour;
	delete [] FirstStartValue;
	delete [] EffectValue;
	delete [] State;
}

////////////////////////////////////////////////////////////////////////////////

int Chrono::hour(int q)
{
	return Hour[q];
}

int Chrono::min(int q)
{
	return Min[q];
}

int Chrono::sec(int q)
{
	return Sec[q];
}

int Chrono::milli(int q)
{
	return Milli[q];
}

int Chrono::state(int q)
{
	return State[q];
}

////////////////////////////////////////////////////////////////////////////////

void Chrono::reinit(int q,int InitValue)
{
	if(q == ALL)
		for(int i=0;i<Nbr;i++)
		{
			EffectValue[i] = InitValue;
			State[i] = INIT;
		}
	else
	{
		EffectValue[q] = InitValue;
		State[q] = INIT;
	}
}

void Chrono::restart(int q)
{
	Moment m;
	m.update();
	if(q == ALL)
		for(int i=0;i<Nbr;i++)
		{
			FirstStartValue[i] = m - EffectValue[i];
			State[i] = START;
		}
	else
	{
		FirstStartValue[q] = m - EffectValue[q];
		State[q] = START;
	}
}

void Chrono::stop(int q)
{
	Moment m;
	m.update();
	if(q == ALL)
		for(int i=0;i<Nbr;i++)
		{
			EffectValue[i] = (int)(m - FirstStartValue[i]);
			Milli[i] = EffectValue[i]%1000;
			Sec[i] = (EffectValue[i]/1000)%60;
			Min[i] = ((EffectValue[i]/1000)/60)%60;
			Hour[i] = ((EffectValue[i]/1000)/60)/60;
			State[i] = STOP;
		}
	else
	{
		EffectValue[q] = (int)(m - FirstStartValue[q]);
		Milli[q] = EffectValue[q]%1000;
		Sec[q] = (EffectValue[q]/1000)%60;
		Min[q] = ((EffectValue[q]/1000)/60)%60;
		Hour[q] = ((EffectValue[q]/1000)/60)/60;
		State[q] = STOP;
	}
}

void Chrono::update(int q)
{
	Moment m;
	m.update();
	if(q == ALL)
		for(int i=0;i<Nbr;i++)
		{
			int n = (int)(m - FirstStartValue[i]);
			Milli[i] = n%1000;
			Sec[i] = (n/1000)%60;
			Min[i] = ((n/1000)/60)%60;
			Hour[i] = ((n/1000)/60)/60;
		}
	else
	{
		int n = (int)(m - FirstStartValue[q]);
		Milli[q] = n%1000;
		Sec[q] = (n/1000)%60;
		Min[q] = ((n/1000)/60)%60;
		Hour[q] = ((n/1000)/60)/60;
	}
}

////////////////////////////////////////////////////////////////////////////////
//  DÉFINITIONS DES FONCTIONS UTILITAIRES DU FICHIER  //////////////////////////

void TimePause(int h,int m,int s,int ms)
{
	timeb t1;
	ftime(&t1);
	int endTime = t1.time+3600*h+60*m+s+(t1.millitm+ms)/1000;
	int endMillitm = (t1.millitm+ms)%1000;
	timeb t2;
	do
	{
		ftime(&t2);
	} while(t2.time < endTime);
	do
	{
		ftime(&t2);
	} while(t2.millitm < endMillitm);
}

////////////////////////////////////////////////////////////////////////////////

