/***************************************************************************
 *   Copyright (C) 2007 by Arnaud Sevin   *
 *   Arnaud.Sevin@obspm.fr   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CLIENT_FTP_H
#define CLIENT_FTP_H

/**
    @author Arnaud Sevin <Arnaud.Sevin@obspm.fr>
 */

/*Si a 1, toutes le erreurs font quitter le prog (RECOMMANDE) sinon 0*/
#define EXIT_ON_ERROR 1
#define DEBUG         0 /*Ligne de debugage principal si a 1*/
#define DISPLAY       0 /*Affichage des résultats si a 1*/

#define NO_ARG ""

#define DEBUG_RECV  0 /*Ligne de debuggage sur les receive COM_D si a 1*/
#define BUFSIZE  2048 /*Taille du buffer*/

#include <iostream>
#include <string>
#include <cstdlib>
#include <cstring>
#include <ctime>

#include <netdb.h>
#include <arpa/inet.h>

#include <fcntl.h>

#include <cstdio>

class Client_FTP{

private :
    int com_d;    /*Descripteur du canal de commande*/
    int dat_d;    /*Descripteur du canal de donnees*/

    int get_cmd_serveur(int);
    char* str_sub (const char *, unsigned int , unsigned int );
    int str_istr ( char *, char *);
    char **str_split (char *, const char *);

    int error(int);
    int error(FILE *p);

    long  fsize(FILE*);

    int new_sock_client(std::string ip, int port);

    void cmd_send(const char*, const char*);
    int cmd_recv(int );
    int one_cmd_recv(int );

    void getmyip(char*);

    int data_recv(int );
    int file_send(const char* );
    int file_recv(const char* );
public :
    Client_FTP(std::string ip, int port=21);
    ~Client_FTP();

    int identification(std::string user, std::string pass);
    int accueil();
    void init();
    void list();
    int noop();
    int get_file(const char *distant_file, const char *local_file);
    int send_file(const char *local_file, const char *distant_file);

};

#endif
