#include "client_FTP.h"

Client_FTP::Client_FTP(std::string ip, int port){
    com_d=new_sock_client(ip, port);
}
;
Client_FTP::~Client_FTP(){
    close(com_d);
    if(dat_d>0){
        close(dat_d);
    }
};

/*Demande a l'utilisateur de s'identifier*/
int Client_FTP::identification(std::string user, std::string pass){
    int code_ret;
    int ret;

    cmd_send("USER",user.c_str());
    code_ret=cmd_recv(DISPLAY);
    if(code_ret == 331){
        cmd_send("PASS",pass.c_str());
        code_ret=cmd_recv(DISPLAY);

        if( (code_ret == 230) || (code_ret == 332) ){
            if(code_ret==332){
                cmd_send("ACCT",NO_ARG);
                cmd_recv(DISPLAY);
            }
            ret = 0;
        }else{
            ret = -1;
        }
    }else{
        ret = -1;
    }

    return ret;
}

/*Affiche le message d'accueil [220]*/
int Client_FTP::accueil(){
    return (cmd_recv(DISPLAY)!=220)?-1:0;
}

/*Initialise le client FTP via des commandes sur le serveur
Type de systeme de fichier SYST
Si le serveur accepte le retrieve REST 0
Le repertoire courant PWD
*/
void Client_FTP::init(){
    cmd_send("SYST",NO_ARG);
    cmd_recv(DISPLAY);
    cmd_send("REST","0");
    cmd_recv(DISPLAY);
    cmd_send("PWD",NO_ARG);
    cmd_recv(DISPLAY);
}

/*Listes les fichiers distants*/
void Client_FTP::list(){
    char cmd[BUFSIZE];
    char adr[255];
    char adresse[255];
    int port,port1,port2,code;
    // tableau contenant l'adresse et l'ip decoupee de connection au serveur
    char** tab_adr;
    int long_chaine;
    char** tabStr;
    long_chaine=0;
    cmd_send("TYPE","I");
    cmd_recv(DISPLAY);

    /*Mode passif*/
    /*Envoi du mode PASV*/
    cmd_send("PASV",NO_ARG);
    /*Reception du port et de l'adresse pour la connection*/
    long_chaine = recv(com_d,cmd,sizeof(cmd),0);
    cmd[long_chaine-2]='\0';
    code = atoi(str_sub(cmd,0,2));
    if(DISPLAY)fprintf(stderr, "%s\n",cmd);
    if(code==227){
/*Modification de la chaine pour trouver l'adresse et le port de reception*/
        strcpy(adr,str_sub(cmd,str_istr(cmd,"(")+1,str_istr(cmd,")")-1));
        tab_adr=str_split(adr,",");
        sprintf(adresse,"%s.%s.%s.%s",
                tab_adr[0],tab_adr[1],tab_adr[2],tab_adr[3]);
        port1 = atoi(tab_adr[4]);
        port2 = atoi(tab_adr[5]);
        port=(port1*256)+port2;
        //sprintf(cmd,"data sur %s:%d",adresse,port);
        //printf("%s\n",cmd);

         dat_d = new_sock_client(adresse,port);

        /*Envoi de la commande LIST*/
        cmd_send("LIST",NO_ARG);
        /*Reception du ACK sur le canal de commande*/
        if(one_cmd_recv(DISPLAY)!=150){ //reception OK avant ou apres ?
            /*Reception de la liste de fichier sur le canal de donnees*/
            data_recv(DISPLAY);
            /*Reception du ACK sur le canal de commande*/
            one_cmd_recv(DISPLAY);
            /*Reception du ACK sur le canal de commande*/
            one_cmd_recv(DISPLAY);
        }else{
            /*Reception de la liste de fichier sur le canal de donnees*/
            data_recv(DISPLAY);
            //Reception du ACK sur le canal de commande*/
            one_cmd_recv(DISPLAY);
            //Reception d'un ACK ?
            one_cmd_recv(DISPLAY);
            //Reception d'un ACK ?
            one_cmd_recv(DISPLAY);
            //verification
            fcntl(com_d,F_SETFL,O_NONBLOCK);
            long_chaine = recv(com_d,cmd,sizeof(cmd),0);
            fcntl(com_d,F_SETFL,O_APPEND);
            cmd[long_chaine]='\0';
            if(long_chaine>0){
                /* \r\n Decoupe la chaine recu et la met dans un tableau*/
                tabStr = str_split(cmd,"\n");
                if(DISPLAY)printf("%s\n",tabStr[0]);
            }
        }
        /*Fermeture du canal de donnee */
        close(dat_d);
    }
}

/*Permet la reception d'un fichier*/
int Client_FTP::get_file(const char *distant_file, const char *local_file){
    int bitsGet=0;
    char cmd[BUFSIZE];
    char adr[255];
    char adresse[255];
    int port,port1,port2,code;

/*tableau contenant l'adresse et l'ip decoupee de connection au serveur*/
    char** tab_adr;
    int long_chaine;
    char** tabStr;


    long_chaine=0;

    /*Mode passif*/
    /*Envoi du TYPE I (image)*/
    if (DEBUG)printf("TYPE i\n");
    cmd_send("TYPE","I");
    cmd_recv(DISPLAY);
    /*Envoi du mode PASV*/
    cmd_send("PASV",NO_ARG);
    /*Reception du port et de l'adresse pour la connection*/
    long_chaine = recv(com_d,cmd,sizeof(cmd),0);
    cmd[long_chaine-2]='\0';
    code = atoi(str_sub(cmd,0,2));
    if(DISPLAY)printf("%s\n",cmd);
    if(code==227){
/*Modification de la chaine pour trouver l'adresse et le port de reception*/
        strcpy(adr,str_sub(cmd,str_istr(cmd,"(")+1,str_istr(cmd,")")-1));
        tab_adr=str_split(adr,",");
        sprintf(adresse,"%s.%s.%s.%s",
                tab_adr[0],tab_adr[1],tab_adr[2],tab_adr[3]);
        port1 = atoi(tab_adr[4]);
        port2 = atoi(tab_adr[5]);
        port=(port1*256)+port2;
        sprintf(cmd,"data sur %s:%d",adresse,port);

        dat_d = new_sock_client(adresse,port);

        /*Envoi de la commande RETR*/
        cmd_send("RETR",distant_file);
        /*Reception du ACK sur le canal de commande*/
        if(one_cmd_recv(DISPLAY)!=150){
            /*Reception du ACK sur le canal de commande*/
            one_cmd_recv(DISPLAY);
            /*Reception de la liste de fichier sur le canal de donnees*/
            /*data_recv(DISPLAY);*/
            bitsGet = file_recv(local_file);
            /*Reception du ACK sur le canal de commande*/
            one_cmd_recv(DISPLAY);
            /*Reception du ACK sur le canal de commande*/
            one_cmd_recv(DISPLAY);
        }else{
            /*Reception de la liste de fichier sur le canal de donnees*/
            file_recv(local_file);
            //Reception du ACK sur le canal de commande*/
            one_cmd_recv(DISPLAY);
            //Reception d'un ACK ?
            one_cmd_recv(DISPLAY);
            //Reception d'un ACK ?
            one_cmd_recv(DISPLAY);
            //verification
            fcntl(com_d,F_SETFL,O_NONBLOCK);
            long_chaine = recv(com_d,cmd,sizeof(cmd),0);
            bitsGet = long_chaine;
            fcntl(com_d,F_SETFL,O_APPEND);
            cmd[long_chaine]='\0';
            if(long_chaine>0){
                /* \r\n Decoupe la chaine recu et la met dans un tableau*/
                tabStr = str_split(cmd,"\n");
                if(DISPLAY)printf("%s\n",tabStr[0]);
            }
        }
        /*Fermeture du canal de donnee */
        close(dat_d);
        /*Reception d'un ACK ?*/
        fcntl(com_d,F_SETFL,O_NONBLOCK);
        long_chaine = recv(com_d,cmd,sizeof(cmd),0);
        fcntl(com_d,F_SETFL,O_APPEND);
        if(long_chaine>0){
            cmd[long_chaine]='\0';
            /* \r\n Decoupe la chaine recu et la met dans un tableau*/
            tabStr = str_split(cmd,"\n");
            if(DISPLAY)printf("%s\n",tabStr[0]);
        }

    }else{
        fprintf(stderr, "Erreur dans la commande.\n");
    }
    return bitsGet;
}

/*Permet l'envoi d'un fichier*/
int Client_FTP::send_file(const char *local_file,const char *distant_file){
    char cmd[BUFSIZE];
    char adr[255];
    char adresse[255];
    int port,port1,port2,code;
    int bitsSend =0;

/*tableau contenant l'adresse et l'ip decoupee de connection au serveur*/
    char** tab_adr;
    int long_chaine;
    char** tabStr;

    long_chaine=0;

    /*Mode passif*/
    /*Envoi du TYPE I (image)*/
    if (DEBUG)printf("TYPE i\n");
    cmd_send("TYPE","I");
    cmd_recv(DISPLAY);
    /*Envoi du mode PASV*/
    cmd_send("PASV",NO_ARG);
    /*Reception du port et de l'adresse pour la connection*/
    long_chaine = recv(com_d,cmd,sizeof(cmd),0);
    cmd[long_chaine-2]='\0';
    code = atoi(str_sub(cmd,0,2));
    if(code==227){
/*Modification de la chaine pour trouver l'adresse et le port de reception*/
        strcpy(adr,str_sub(cmd,str_istr(cmd,"(")+1,str_istr(cmd,")")-1));
        tab_adr=str_split(adr,",");
        sprintf(adresse,"%s.%s.%s.%s",
                tab_adr[0],tab_adr[1],tab_adr[2],tab_adr[3]);
        port1 = atoi(tab_adr[4]);
        port2 = atoi(tab_adr[5]);
        port=(port1*256)+port2;
        sprintf(cmd,"data sur %s:%d",adresse,port);

        dat_d = new_sock_client(adresse,port);
        /*Envoi de la commande STOR*/
        cmd_send("STOR",distant_file);
        /*Reception du ACK sur le canal de commande*/
        if(one_cmd_recv(DISPLAY)==150){
            /*Reception du ACK sur le canal de commande*/
            bitsSend = file_send(local_file);
        }else{
            fprintf(stderr, "Erreur dans la commande.\n");
        }
        /*Fermeture du canal de donnee */
        close(dat_d);

        cmd_recv(DISPLAY);
        cmd_send("NOOP",NO_ARG);
        cmd_recv(DISPLAY);
        fcntl(com_d,F_SETFL,O_NONBLOCK);
        long_chaine = recv(com_d,cmd,sizeof(cmd),0);
        fcntl(com_d,F_SETFL,O_APPEND);
        if(long_chaine>0){
            cmd[long_chaine]='\0';
            /* \r\n Decoupe la chaine recu et la met dans un tableau*/
            tabStr = str_split(cmd,"\n");
            if(DISPLAY)printf("%s\n",tabStr[0]);
        }
    }else{
        fprintf(stderr, "Erreur dans la commande.\n");
    }
    return bitsSend;
}

int Client_FTP::noop(){
    cmd_send("NOOP",NO_ARG);
    return cmd_recv(DISPLAY);
}
/*Creer une sous-chaine a partir d'une chaine, indice de debut et fin*/
char *Client_FTP::str_sub (const char *s,
                           unsigned int start, unsigned int end){
    char *new_s = NULL;
    unsigned int i;
    if (s && start <= end){
        new_s = (char *)malloc (sizeof (*new_s) * (end - start + 2));
        if (new_s){
            for (i = start; i <= end; i++){
                new_s[i-start] = s[i];
            }
            new_s[end - start + 1] = '\0';
        }
        else{
            fprintf (stderr, "Memoire insuffisante\n");
            exit (EXIT_FAILURE);
        }
    }
    return new_s;
}

/*permet de trouver l'adresse d'une sous-chaine ct dans une chaine cs*/
int Client_FTP::str_istr ( char *cs, char *ct){
    int index = -1;

    if (cs && ct)
    {
        char *ptr_pos = NULL;

        ptr_pos = strstr (cs, ct);
        if (ptr_pos)
        {
            index = ptr_pos - cs;
        }
    }
    return index;
}

// Decoupe une chaine s suivant le delimiteur ct et
// retourne un tableau de chaine
char **Client_FTP::str_split (char *s, const char *ct){
    char **tab = NULL;

    if (s && ct)
    {
        unsigned int i;
        char *cs = NULL;
        size_t size = 1;

        for (i = 0; (cs = strtok (s, ct)); i++)
        {
            if (size <= i + 1)
            {
                char **tmp = NULL;

                size <<= 1;
                tmp = (char **)realloc (tab, sizeof (*tab) * size);
                if (tmp)
                {
                    tab = tmp;
                }
                else
                {
                    fprintf (stderr, "Memoire insuffisante\n");
                    free (tab);
                    tab = NULL;
                    exit (EXIT_FAILURE);
                }
            }
            tab[i] = cs;
            s = NULL;
        }
        tab[i] = NULL;
    }
    return tab;
}

/*verifie si une erreur s'est produite*/
int Client_FTP::error(int p){
    if(p<0){
        perror("Erreur");
        if(EXIT_ON_ERROR) exit(p);
    }
    return p;
}

/*verifie si une erreur s'est produite*/
int Client_FTP::error(FILE *p){
    if(p==0L){
        perror("Erreur");
        if(EXIT_ON_ERROR) exit(0);
    }
    return 0;
}

/*taille du fichier (binaire, pas texte) */
long  Client_FTP::fsize(FILE* fd){
    long savepos, size;
    savepos = ftell(fd);          /* sauvegarder la position  */
    fseek(fd, 0, SEEK_END);       /* aller en fin */
    size = ftell(fd);             /* lire la taille */
    fseek(fd, savepos, SEEK_SET); /* retablir la position */
    return size;
}

/*Cree un nouveau socket CLIENT via une ip ou un nom de serveur + un port*/
int Client_FTP::new_sock_client(std::string ip, int port) {

    int fd;
    struct hostent * host;
    struct sockaddr_in sock_in;

    memset(&sock_in,0,sizeof(struct sockaddr_in));
    host = gethostbyname(ip.c_str());

    sock_in.sin_family = AF_INET;
    sock_in.sin_port = htons(port);

    memcpy( (char *)&sock_in.sin_addr.s_addr,
             host->h_addr_list[0],host->h_length);
    //sock_in.sin_addr.s_addr = ((struct in_addr *) (host->h_addr))->s_addr;

    /*Creation du socket*/
    fd = error(socket(host->h_addrtype,SOCK_STREAM,0));

    /*attachement du socket*/
    error(connect(fd,(struct sockaddr *)&sock_in,sizeof(sock_in)));

    return fd; /*Retourne le descripteur de socket*/
}

/*Retourne une IP  sous forme 127,0,0,1 pour connection par PORT !*/
void Client_FTP::getmyip(char* getmyip){
    struct hostent * host;
    struct in_addr **adr;
    int i;

    host = gethostbyname("localhost");
    adr = (struct in_addr **) host->h_addr_list;
    if(adr[1]!=NULL)
        strcpy(getmyip,inet_ntoa(*adr[1]));
    else strcpy(getmyip,inet_ntoa(*adr[0]));
    i=0;
    while(getmyip[i]!='\0'){
        if(getmyip[i]=='.'){
            getmyip[i]=',';
        }
        i++;
    }
}

/*Permet l'envoi d'une commande au canal de commande*/
void Client_FTP::cmd_send(const char * cmd, const char * arg){
    char buf[255];
    if(strcmp(arg,NO_ARG)==0){
        sprintf(buf,"%s\r\n",cmd);
    }else{
        sprintf(buf,"%s %s\r\n",cmd,arg);
    }

//     fprintf(stderr, "buf = %s\n", buf);
    error(send(com_d,buf,strlen(buf),0));
}

/*Permet la reception des cmds sur la canal de commande*/
int Client_FTP::cmd_recv(int display /*display 1/0*/){
    int long_chaine;
    char cmd2[BUFSIZE] ;
    char** tabStr;
    int code=0, fin,t,code_buf;

    fin=0;
    do{
        long_chaine = recv(com_d,cmd2,sizeof(cmd2),0);
        cmd2[long_chaine]='\0';
        if(DEBUG_RECV)printf("LONGCH => %s <= LONGCH\n",cmd2);
        if (long_chaine>0){ /*une chaine a ete recu*/
            /* \r\n Decoupe la chaine recu et la met dans un tableau*/
            tabStr = str_split(cmd2,"\n");
            t=0;
            do{
                code_buf = atoi(str_sub(tabStr[t],0,2));

                if ( (strcmp(str_sub(tabStr[t],3,3)," ")==0) &&
                     (atoi(str_sub(tabStr[t],0,2)))>99          ){
                    if(DEBUG_RECV)printf("Indicateur de fin trouve!\n");
                    fin=1;
                    code = code_buf;
                }
                if (display==1) {
                    if((str_istr(tabStr[t],"\r")<0)){
                        printf("%s",tabStr[t]);
                    }else{
                        printf("%s\n",tabStr[t]);
                    }
                }
                t++;
            }while(tabStr[t]!=NULL);

            if(DEBUG_RECV)printf("Nb ch recu : %d, fin = %d\n",t,fin);
        }
        else{
            fin=1;
        }
    }while(fin==0);

    return code;
}

/*Permet la reception des data sur la canal de data*/
int Client_FTP::data_recv(int display /*display 1/0*/){
    int bitsGet=0;
    fd_set rfds;
    int long_chaine;
    char cmd[BUFSIZE];
    struct timeval tv;
    int retval;

    do {
        /* Surveiller en attente d'entrees */
        FD_ZERO(&rfds);
        FD_SET(dat_d, &rfds);
        /* Pendant 500 milli secondes maxi */
        tv.tv_sec = 1;
        tv.tv_usec = 0;
        long_chaine = recv(dat_d,cmd,sizeof(cmd),0);
        bitsGet+=long_chaine;
        cmd[long_chaine]='\0';
        if(display==1)fprintf(stderr,"%s",cmd);
        retval = select(dat_d+1, &rfds, NULL, NULL,&tv);
        if(long_chaine<3) retval=0;
    }while(retval!=0 && FD_ISSET(dat_d,&rfds));
    return bitsGet;
}

/*Permet la reception d'un fichier  sur la canal de data*/
int Client_FTP::file_recv(const char* filename){
    int bitsGet=0;
    fd_set rfds;
    int long_chaine;
    char ligne[BUFSIZE];
    struct timeval tv;
    int retval;
    FILE* file;
    long size;
    time_t t_avant;
    time_t t_apres;
    char resulSTR[255];
    double diff_time;
    file = fopen(filename,"w+"); /*On cree un fichier pour ecrire dedans*/

    time(&t_avant);
    do {
        /* Surveiller en attente d'entrees */
        FD_ZERO(&rfds);
        FD_SET(dat_d, &rfds);
        /* Pendant 500 milli secondes maxi */
        tv.tv_sec = 0;
        tv.tv_usec = 500;
        /*Fin de stockage pour cette chaine*/
        while((long_chaine=recv(dat_d,ligne,512,0)) != 0){
            bitsGet+=long_chaine;
            fwrite(ligne, 1, long_chaine, file);
            if(DEBUG_RECV)
                fprintf(stderr, "Reception de %d octets\r",long_chaine);
        }
        /*fin de copie*/
        retval = select(dat_d+1, &rfds, NULL, NULL, &tv);
        if(long_chaine<2)retval=0; //fin de fichier
    }while(retval>0 && FD_ISSET(dat_d,&rfds));
    time(&t_apres);
    if(DISPLAY) {
        size = fsize(file); /*Recuperation de la taille*/
        /*On s'assure de vider le buffer avant de fermer le fichier*/
        fflush(file);
        fclose(file); /*On ferme le fichier*/
        diff_time= difftime(t_apres,t_avant);
        if(diff_time<1)diff_time=1;
        sprintf(resulSTR, "Transfert de %ld octets en %.0f s (%.2f Ko/s).",
                size,diff_time,(size/diff_time)/1000.);
        printf("%s\n",resulSTR);
    }
    return bitsGet;
}

/*Permet l'envoi d'un fichier  sur la canal de data*/
int  Client_FTP::file_send(const char* filename){
    fd_set rfds;
    int long_chaine;
    int long_chaineSend;
    int bitsSend=0;
    char ligne[BUFSIZE];
    struct timeval tv;
    int retval;
    FILE* file;
    long size;
    time_t t_avant;
    time_t t_apres;
    char resulSTR[255];

    float moyenne;
    float diff;

    /* Surveiller en attente d'entrees */
    FD_ZERO(&rfds);
    FD_SET(dat_d, &rfds);
    /* Pendant 500 milli secondes maxi */
    tv.tv_sec = 0;
    tv.tv_usec = 500;
    time(&t_avant);

    do {
        /*Fin de stockage pour cette chaine*/
        error(file = fopen(filename,"r"));
        while( (long_chaine=fread(ligne, 1, BUFSIZE, file)) != 0){
            long_chaineSend=0;
            while(long_chaineSend<long_chaine){
                error(long_chaineSend+=send(dat_d,&ligne[long_chaineSend],long_chaine-long_chaineSend,0));
            }
            bitsSend+=long_chaineSend;
        }
        size = fsize(file); /*Recuperation de la taille*/

        /*On s'assure de vider le buffer avant de fermer le fichier*/
        fflush(file);
        error(fclose(file));

        if(DEBUG_RECV)fprintf(stderr, "Envoi de %d octets\n%s\n",
                                       long_chaine,ligne);
        /*fin de copie*/
        retval = select(dat_d, &rfds, NULL, NULL, &tv);
        tv.tv_sec = 0;
        tv.tv_usec = 500;
    }while(retval>0);
    time(&t_apres);
    if(DISPLAY) {
        diff = difftime(t_apres,t_avant);
        if(diff<1)diff=1;
        moyenne= (size/diff)/(1000);
        sprintf(resulSTR,"Transfert de %ld octets en %.0f s (%.2f Ko/s).",
                size,diff,moyenne);
        printf("%s\n",resulSTR);
    }
    return bitsSend;
}

/*Permet la reception d'une  COMMANDE sur la canal de commande*/
int Client_FTP::one_cmd_recv(int display /*display 1/0*/){
    fd_set rfds;
    int long_chaine;
    char cmd[BUFSIZE];
    struct timeval tv;
    int retval;
    int code;

    /* Surveiller en attente d'entrees */
    FD_ZERO(&rfds);
    FD_SET(com_d, &rfds);
    /* Pendant 500 milli secondes maxi */
    tv.tv_sec = 1;
    tv.tv_usec = 0;
    retval = select(com_d+1, &rfds, NULL, NULL, &tv);
    if(retval>0 && FD_ISSET(com_d,&rfds)){
        long_chaine = recv(com_d,cmd,sizeof(cmd),0);
        cmd[long_chaine-2]='\0';
        if(DISPLAY==1) printf("%s\n",cmd);
        code = atoi(str_sub(cmd,0,2));
        return code;
    }else{
        return -1;
    }
}
