.TH find_fringes_outliers S 2014-Oct-01 CHARA libchara CHARA
.SH NAME
find_fringes_outliers
.SH SYNOPSIS
.nf
#include <stdlib.h>
#include <string.h>
#include "../nrc/nrc.h"
#include <unistd.h>
#include <math.h>
#include "chara.h"
#include <malloc/malloc.h>
#include <malloc.h>

int find_fringes_outliers(float *data, int n, float rms_noise,
			  float threshold, int min_number_fringes)
.fi
.SH DESCRIPTION
Takes a 1D scan DATA of size 1..N and detects fringe packet.
!Assume that there is only one fringe packet in DATA scan!
- if fringes are not found, returns -1
- if fringes are found, returns the position of the fringe
packet inside the scan (within 0..N-1)

requires:
- RMS_NOISE: root mean square of a scan without fringes (noise)
- THRESHOLD: number of sigmas above the noise for wich
one considers a fringe is detected
- MIN_NUMBER_FRINGES

the function will detect all fringes and return the median
index of these detections.

author: Antoine Merand 2006/12/05
.SH SOURCE FILE
fringe_track.c
.SH AUTHOR
 Theo ten Brummelaar
