/************************************************************************/
/* charaoif.h								*/
/*                                                                      */
/* The sheader file for CHARA OIFITS stuff				*/
/************************************************************************/
/*                                                                      */
/*     Center for High Angular Resolution Astronomy                     */
/* Georgia State University, Atlanta GA 30303-3083, U.S.A.              */
/*                                                                      */
/*                                                                      */
/* Telephone: 1-404-651-1882                                            */
/* Fax      : 1-404-651-1389                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu/~theo/theo.html                  */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar et al.                                  */
/* Date   :                                                             */
/************************************************************************/

#ifndef __CHARAOIF__
#define __CHARAOIF__

/* charaoif.c */

int setup_oi_array(oi_array *array);
void clear_oi_array(oi_array array);
void setup_oi_wavelength(oi_wavelength *wave, char *name); 
int add_oi_wavelength(oi_wavelength *wave, float lambda, float dlambda);
void clear_oi_wavelength(oi_wavelength wave);
void setup_oi_target(oi_target *targets);
int add_oi_target(oi_target *targets, struct s_star star);
void clear_oi_target(oi_target targets);
void setup_oi_vis(oi_vis *vis, char *date, char *arrname,
		char *insname, int nwave);
int add_oi_vis(oi_vis *vis, int id, double time, 
		double mjd, double int_time, 
		double *visamp, double *visamperr,
		double *visphi, double *visphierr,
		double u, double v, int scope1, int scope2);
void clear_oi_vis(oi_vis vis);
void setup_oi_vis2(oi_vis2 *vis2, char *date, char *arrname,
		char *insname, int nwave);
int add_oi_vis2(oi_vis2 *vis2, int id, double time, 
		double mjd, double int_time, 
		double *vis2data, double *vis2err,
		double u, double v, int scope1, int scope2);
void clear_oi_vis2(oi_vis2 vis2);
void setup_oi_t3(oi_t3 *t3, char *date, char *arrname,
		char *insname, int nwave);
int add_oi_t3(oi_t3 *t3, int id, double time, 
		double mjd, double int_time, 
		double *t3amp, double *t3amperr,
		double *t3phi, double *t3phierr,
		double u1, double v1, double u2, double v2,
		int scope1, int scope2, int scope3);
void clear_oi_t3(oi_t3 t3);
void print_oi_array(FILE *fp, oi_array array);
void print_oi_wavelength(FILE *fp, oi_wavelength wave);
void print_oi_target(FILE *fp, oi_target target);
void print_oi_vis(FILE *fp, oi_vis vis);
void print_oi_vis2(FILE *fp, oi_vis2 vis2);
void print_oi_t3(FILE *fp, oi_t3 t3);

#endif
