/************************************************************************/
/* shell.c								*/
/*                                                                      */
/* 	Allows the user to enter a shell of the operating system.	*/
/* The functions are:							*/
/*		ui_shell() - Gives access to command shell		*/
/*		os_utils() - Utilities for some os calls		*/
/*		view_dir() - Shows you a directory (via os_utils())	*/
/************************************************************************/
/*                                                                      */
/*                    CHARA ARRAY USER INTERFACE			*/
/*                 Based on the SUSI User Interface			*/
/*		In turn based on the CHIP User interface		*/
/*                                                                      */
/*            Center for High Angular Resolution Astronomy              */
/*              Mount Wilson Observatory, CA 91001, USA			*/
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu			                */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Tony Johnson & Theo ten Brummelaar                          */
/* Date   : Original Version 1990 - ported to Linux 1998                */
/************************************************************************/

/*
 * Include files
 */

#include "charaui.h"

/************************************************************************/
/* ui_shell()								*/
/*									*/
/* Allows the user to enter a shell of the operating system.		*/
/*									*/
/************************************************************************/

int	ui_shell(int argc, char **argv)
{
	no_socket();

	plain_screen_on();

	/* up exit message */

	printf("Exit shell to return to program.\r\n");
	fflush(stdout);

	/* Get the SHELL variable */

	if (getenv("SHELL") == (char *)NULL)
	{
		putchar('\n');
		system("sh");
	}
	else
	{
		putchar('\n');
		system("stty sane");
		system(getenv("SHELL"));
	}

	/* return to programme */

	plain_screen_off();
	wrefresh(curscr);

        /* Make the stdin nonblocking again for the kbhit() function. */

        if (fcntl(fileno(stdin), F_SETFL, O_NONBLOCK) == -1)
                error(FATAL,"Failed to make stdin non-blocking.");

	return NOERROR;

} /* ui_shell() [14.8] */
