/************************************************************************/
/* title.c								*/
/*                                                                      */
/* Routines for putting up title page.					*/
/************************************************************************/
/*                                                                      */
/*                    CHARA ARRAY USER INTERFACE			*/
/*                 Based on the SUSI User Interface			*/
/*		In turn based on the CHIP User interface		*/
/*                                                                      */
/*            Center for High Angular Resolution Astronomy              */
/*              Mount Wilson Observatory, CA 91001, USA			*/
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu			                */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Tony Johnson & Theo ten Brummelaar                          */
/* Date   : Original Version 1990 - ported to Linux 1998                */
/************************************************************************/

/*
 * Include files
 */

#include "charaui.h"

/************************************************************************/
/* wait_for_title()							*/
/* Process 2								*/
/*									*/
/* Forces a three second wait after flushing the stdout.		*/
/*									*/
/************************************************************************/

void	wait_for_title(void)
{
	/* internal variables */

	time_t		start_time;	/* Starting time for pause */
	time_t		stop_time;	/* Stopping time for pause */

	fflush(stdout);

	/* Let it show for a while */

	for (time(&start_time); time(&stop_time) < start_time + 2;);

} /* wait_for_title() */

/************************************************************************/
/* center_line()							*/
/*									*/
/* Centre line of text between two sets of the character '|'.		*/
/* Uses ASCII characters only.						*/
/*									*/
/************************************************************************/

void 	center_line(char *string)
{
	/* internal variables */

	int	i;			/* looping variable */
	int	length;			/* ...of string */

	length = strlen(string);

	length = (BOX_WIDTH - length) / 2;
	for(i=0; i<length; i++) putchar(' ');
	printf("%s", string);
	putchar('\n');

} /* center_line() */

/************************************************************************/
/* put_line()								*/
/*									*/
/* Put line of text between two sets of the character '|'.		*/
/* Use ASCII characters only.						*/
/*									*/
/************************************************************************/

void 	put_line(char *string)
{
	printf("%s", string);
	putchar('\n');

} /* put_line() */
