/************************************************************************/
/* cliserv_fast_clock.h							*/
/*                                                                      */
/* Header file for the fast clock client controller.			*/
/************************************************************************/
/*                                                                      */
/*     Center for High Angular Resolution Astronomy                     */
/* Georgia State University, Atlanta GA 30303-3083, U.S.A.              */
/*                                                                      */
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu/~theo/theo.html                  */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar						*/
/* Date   : DEC 2004                                               	*/
/************************************************************************/

#ifndef __FAST_CLOCK_CLISERV__
#define __FAST_CLOCK_CLISERV__

#define FAST_CLOCK_MAIN_WIDTH 150

/* Globals */

/* Most recent rt_timefrom server */

extern fast_clock_time_struct fast_time[MAX_SERVERS];  
extern int fast_clock_rate[MAX_SERVERS];  
extern int fast_clock_cal_time[MAX_SERVERS];  

struct control_window_data {char *name; int server; };

/* Prototypes */

/* clock_control_wondow.c */

GtkWidget* create_fast_clock_control_window(GtkButton *button, gpointer *data);
void fast_clock_control_ok_callback(GtkButton *button, gpointer user_data);
gint fast_clock_control_background(gpointer data);
void fast_clock_control_clear_callback(GtkButton *button, gpointer user_data);
void fast_clock_control_cal_callback(GtkWidget *button, gpointer user_data);
void fast_clock_control_stop_cal_callback(GtkButton *button, gpointer user_data);
void fast_clock_control_rate_callback(GtkWidget *button, gpointer user_data);
void fast_clock_control_period_callback(GtkWidget *button, gpointer user_data);

/* clock_messages.c */

int setup_fast_clock_messages(int server);
int message_fast_clock_calibration_info(int server, struct smessage *mess);
int message_fast_clock_set_rate(int server, struct smessage *mess);
int message_fast_clock_time(int server, struct smessage *mess);

#endif
