/************************************************************************/
/* ui_huT_client.h							*/
/*                                                                      */
/************************************************************************/
/*                                                                      */
/*     Center for High Angular Resolution Astronomy                     */
/* Georgia State University, Atlanta GA 30303-3083, U.S.A.              */
/*                                                                      */
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu/~theo/theo.html                  */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar                                         */
/* Date   : OCT 2004	                                                */
/************************************************************************/

#ifndef __UI_HUT_CLIENT__
#define __UI_HUT_CLIENT__

#define NUM_HUT_EXP 15

extern struct s_hut huT;
extern int huT_server;
extern char *huT_file_name;
extern float huT_exp_times[NUM_HUT_EXP+1];

/* huT_messages.c */

int open_huT_server_socket(char *name, bool send_huT_value);
int message_huT_now(int server, struct smessage *mess);
int message_huT_file_name(int server, struct smessage *mess);
 int message_huT_aob_status(int server, struct smessage *mess);
char *get_huT_file_name(void);
int hut_reset_comms(int argc, char **argv);
int hut_heater_on(int argc, char **argv);
int hut_heater_off(int argc, char **argv);
int hut_dehum_on(int argc, char **argv);
int hut_dehum_off(int argc, char **argv);
int hut_auto_on(int argc, char **argv);
int hut_auto_off(int argc, char **argv);
int send_huT_all_clients(void);

#endif
