/************************************************************************/
/* uishut.h								*/
/*                                                                      */
/* Standard user interface based client header file.			*/
/************************************************************************/
/*                                                                      */
/*     Center for High Angular Resolution Astronomy                     */
/* Georgia State University, Atlanta GA 30303-3083, U.S.A.              */
/*                                                                      */
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu/~theo/theo.html                  */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar                                         */
/* Date   : AUGUST 2002							*/
/************************************************************************/

#ifndef __UISHUT__
#define __UISHUT__

extern int    shut_server;
extern char   *shutter_types[];
extern char   *shutter_status_types[];

/* Prototypes */

/* uishut_standard.c */

int set_up_shutter_jobs(void);
int message_shutter_status(int server, struct smessage *mess);
int message_shutter_conf(int server, struct smessage *mess);
int send_shutter_open(unsigned char shutter);
int send_shutter_close(unsigned char shutter);
int send_shutter_status(unsigned char shutter);
int open_shutter_server(void);
int call_open_shutter_server(int argc, char **argv);
int close_shutter_server(int argc, char **argv);
int get_shutter_number(int argc, char **argv);
int shutter_id(char *name);
int shutter_open(int argc, char **argv);
int shutter_close(int argc, char **argv);
int shutter_all_close(int argc, char **argv);
int get_shutter_status(int shutter, unsigned char *status);
int call_shutter_status(int argc, char **argv);
int monitor_shutters(int argc, char **argv);
int shutter_config(int argc, char **argv);
int alternate_ir_shutters(int argc, char **argv);
int call_send_ping_shut(int argc, char **argv);
#endif
