/************************************************************************/
/* uizaber.h								*/
/*                                                                      */
/* UI base client for zabermotor server.				*/
/************************************************************************/
/*                                                                      */
/*     Center for High Angular Resolution Astronomy                     */
/* Georgia State University, Atlanta GA 30303-3083, U.S.A.              */
/*                                                                      */
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu/~theo/theo.html                  */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar                                         */
/* Date   : SEPTEMBER 1998                                              */
/************************************************************************/

#ifndef __UIZABER__
#define __UIZABER__

extern struct SZABER_LIST zaber_list[MAX_SERVERS];

/* uizaber_messages.c */

void set_bypass_zaber(bool bypass);
int open_zaber_server(char *name);
int message_zaber_list(int server, struct smessage *mess);
int message_zaber_unit_position(int server, struct smessage *mess);
bool zaber_get_units_by_name(int server, 
			     char *name, 
			     int *axis_one, 
			     int *axis_two);
bool zaber_move_unit_absolute(int server, int unit, int position);
bool zaber_move_unit_relative(int server, int unit, int position);
bool zaber_move_set_point(int server, int unit);
bool zaber_move_home(int server, int unit);
bool zaber_init(int server);
bool zaber_move_unit_absolute_wait(int server, int unit, int position);
bool zaber_move_unit_relative_wait(int server, int unit, int position);
int get_zaber_position(int server, int unit);

#endif
