#include "cpk.h"

void cpkS2v ( double a, double b, double v[3] )

/*
**  - - - - - - -
**   c p k S 2 v
**  - - - - - - -
**
**  Spherical coordinates to unit vector.
**
**  Given:
**     a       d     longitude angle (e.g. RA) in radians
**     b       d     latitude angle (e.g. Dec) in radians
**
**  Returned:
**     v      d[3]   unit vector
**
**  Notes:
**
**    1  No validation of the arguments is performed.
**
**    2  Right-handed coordinate systems are assumed:  call using
**       (RA,Dec), (-HA,Dec) or (pi-Az,El).
**
**  Last revision:   9 January 2007
**
**  Copyright P.T.Wallace.  All rights reserved.
*/

{

   cpkS2c ( a, b, v, v+1, v+2 );

}
