#include "cpk.h"
#include <string.h>

int cpkScomp ( char *string1, char *string2 )

/*
**  - - - - - - - - -
**   c p k S c o m p
**  - - - - - - - - -
**
**  Compare two strings ignoring trailing whitespace.
**
**  Given:
**     *string1     char     first string
**     *string2     char     second string
**
**  Returned (function value):
**                  int      0 = strings are the same apart
**                               from any trailing whitespace
**
**  Called:  cpkLength
**
**  Last revision:   9 January 2007
**
**  Copyright P.T.Wallace.  All rights reserved.
*/
{
   int l1, l2;


   l1 = cpkLength ( string1 );
   l2 = cpkLength ( string2 );
   return strncmp ( string1, string2, ( l1 > l2 ) ? l1 : l2 );

}
