#include "cpk.h"

double cpkTday ( int ih, int im, double s )

/*
**  - - - - - - - -
**   c p k T d a y
**  - - - - - - - -
**
**  Time of day from hours, minutes, seconds to fraction of a day.
**
**  Given:
**     ih       i    hour
**     im       i    minute
**     s        d    seconds
**
**  Returned (function value):
**              d    fraction of 1 day
**
**  Notes:
**
**    1  No validation of the arguments is performed.  The three numbers
**       are simply combined arithmetically, and can be negative or
**       outside the conventional ranges.
**
**  Last revision:   9 January 2007
**
**  Copyright P.T.Wallace.  All rights reserved.
*/

{
   return ( 60.0 * (double) ( 60*ih + im ) + s ) / 86400.0;
}
