#include "cpk.h"

void cpkV2s ( double v[3], double *a, double *b )

/*
**  - - - - - - -
**   c p k V 2 s
**  - - - - - - -
**
**  Vector to spherical coordinates.
**
**  Given:
**     v      d[3]   vector
**
**  Returned:
**     a       d*    longitude angle (e.g. RA) in radians
**     b       d*    latitude angle (e.g. Dec) in radians
**
**  Notes:
**
**    1  The vector does not have to be a unit vector:  only its
**       direction is significant.
**
**    2  Right-handed coordinate systems are assumed:  RA=a, HA=-a,
**       Az=pi-a.
**
**  Last revision:   9 January 2007
**
**  Copyright P.T.Wallace.  All rights reserved.
*/

{

   cpkC2s ( v[0], v[1], v[2], a, b );

}
