/*
 *
 *	pixcipub.h	External	23-Nov-2010
 *
 *	Copyright (C)  2006-2010  EPIX, Inc.  All rights reserved.
 *
 *	Frame Grabber Driver: Linux Device Driver wrappers,
 *	allowing partial compilation of the frame grabber driver
 *	in the field.
 *
 */


/*
 * Wrappers: Driver internals to Linux.
 */
struct pci_dev; 	// existent(?) and very opaque
struct task_struct;	// existent(?) and very opaque
struct semaphore;	// existent(?) and very opaque
struct timer_list;	// existent(?) and very opaque
struct pt_regs; 	// existent(?) and very opaque

#define _cfunregparm0	__attribute__((regparm(0)))

void*  _cfunregparm0 wrapper_kmalloc(size_t size);
void   _cfunregparm0 wrapper_kfree(void *ptr);
struct semaphore * _cfunregparm0 wrapper_kmalloc_semaphore(int value);
struct timer_list * _cfunregparm0 wrapper_kmalloc_timer_list(void);
ulong  _cfunregparm0 wrapper_get_free_pages(int nowarn, uint order, int dma32);
void   _cfunregparm0 wrapper_free_pages(ulong adrs, uint order);
int    _cfunregparm0 wrapper_request_region(ulong start, ulong len, char *name);
void   _cfunregparm0 wrapper_release_region(ulong start, ulong len);
int    _cfunregparm0 wrapper_request_mem_region(ulong start, ulong len, char *name);
void   _cfunregparm0 wrapper_release_mem_region(ulong start, ulong len);
void*  _cfunregparm0 wrapper_ioremap(ulong adrs, ulong size);
void   _cfunregparm0 wrapper_iounmap(void *adrs);
int    _cfunregparm0 wrapper_copy_to_user(void *to, const void *from, ulong count);
int    _cfunregparm0 wrapper_copy_from_user(void *to, const void *from, ulong count);
int    _cfunregparm0 wrapper_put_user_long(long value, long *ptr);
int    _cfunregparm0 wrapper_pci_present(void);
int    _cfunregparm0 wrapper_pci_write_config_dword(struct pci_dev *dev, int where, u32 value);
int    _cfunregparm0 wrapper_pci_read_config_dword(struct pci_dev *dev, int where, u32 *value);
int    _cfunregparm0 wrapper_pci_enable_device(struct pci_dev *dev);
struct pci_dev * _cfunregparm0 wrapper_pci_get_device(uint vendor, uint device, struct pci_dev *last);
void   _cfunregparm0 wrapper_pci_dev_put(struct pci_dev *dev);
int    _cfunregparm0 wrapper_pci_resource_flags_io(struct pci_dev *dev, int index);
ulong  _cfunregparm0 wrapper_pci_resource_start(struct pci_dev *dev, int index);
ulong  _cfunregparm0 wrapper_pci_resource_len(struct pci_dev *dev, int index);
int    _cfunregparm0 wrapper_pci_dev_irq(struct pci_dev *dev);
int    _cfunregparm0 wrapper_pci_dev_bus_number(struct pci_dev *dev);
void   _cfunregparm0 wrapper_down(struct semaphore *sem);
void   _cfunregparm0 wrapper_up(struct semaphore *sem);
void   _cfunregparm0 wrapper_add_timer(struct timer_list *timer, void (*func)(ulong data), ulong data, ulong millis);
void   _cfunregparm0 wrapper_init_timer(struct timer_list *timer);
void   _cfunregparm0 wrapper_del_timer_sync(struct timer_list *timer);
ulong  _cfunregparm0 wrapper_jiffies(void);
ulong  _cfunregparm0 wrapper_HZ(void);
char*  _cfunregparm0 wrapper_UTS_RELEASE(void);
ulong  _cfunregparm0 wrapper_num_physpages(void);
int    _cfunregparm0 wrapper_send_sig(int sig, struct task_struct *task, int z);
struct task_struct * _cfunregparm0 wrapper_get_current(void);
ulong  _cfunregparm0 wrapper_virt_to_bus(void *p);
u32    _cfunregparm0 wrapper_inl(ulong port);
void   _cfunregparm0 wrapper_outl(u32 data, ulong port);
u32    _cfunregparm0 wrapper_readl(void *adrs);
void   _cfunregparm0 wrapper_writel(u32 data, void *adrs);
#if defined(CONFIG_X86_64)
u64    _cfunregparm0 wrapper_readq(void *adrs);
void   _cfunregparm0 wrapper_writeq(u64 data, void *adrs);
#endif
void   _cfunregparm0 wrapper_disable_irq(int irq);
void   _cfunregparm0 wrapper_enable_irq(int irq);
void   _cfunregparm0 wrapper_schedule(void);
void   _cfunregparm0 wrapper_gettimeofday(time_t *ssecp, long *usecp);
void   _cfunregparm0 wrapper_mdelay(ulong msecs);
void   _cfunregparm0 wrapper_udelay(ulong usecs);
void   _cfunregparm0 wrapper_msleep(uint msecs);

#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,19))
int _cfunregparm0 wrapper_request_irq(uint irq,
		       irqreturn_t (*handler)(int, void*),
		       int shareirq, const char* dev_name, void *dev_id);
void _cfunregparm0 wrapper_free_irq(uint irq, void *dev_id);
#elif (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0))
int _cfunregparm0 wrapper_request_irq(uint irq,
		       int (*handler)(int, void*, struct pt_regs *),
		       int shareirq, const char* dev_name, void *dev_id);
void _cfunregparm0 wrapper_free_irq(uint irq, void *dev_id);
#else
int _cfunregparm0 wrapper_request_irq(uint irq,
		       void (*handler)(int, void*, struct pt_regs *),
		       int shareirq, const char* dev_name, void *dev_id);
void _cfunregparm0 wrapper_free_irq(uint irq, void *dev_id);
#endif

void   _cfunregparm0 wrapper_ttyinsertflipchar(void *tty, int c, int brkflag, int overrunflg);

/*
 * Wrappers: Linux driver API to internals.
 */
int  _cfunregparm0 wrapper_init_pxdrvlnx(int major, char *parms, ulong hz, size_t page_size, int irq_handled, int irq_none, int *nttyp);
int  _cfunregparm0 wrapper_cleanup_pxdrvlnx(void);
int  _cfunregparm0 wrapper_pxdrv_ioctl(void *, void *, uint cmd, ulong arg);
int  _cfunregparm0 wrapper_pxdrv_open(void *, void *);
int  _cfunregparm0 wrapper_pxdrv_release(void *, void *);
int  _cfunregparm0 wrapper_pxdrv_mmapdope0(ulong start, ulong end, ulong pgoff);
void*_cfunregparm0 wrapper_pxdrv_mmapdope1(ulong adrs);
void*_cfunregparm0 wrapper_ttyopen(void *tty, int index);
void _cfunregparm0 wrapper_ttyclose(void *tty, void *pxtty);
int  _cfunregparm0 wrapper_ttywrite(void *tty, void *pxtty, const void *buffer, int count);
int  _cfunregparm0 wrapper_ttywriteroom(void *tty, void *pxtty);
int  _cfunregparm0 wrapper_ttycharsinbuffer(void *tty, void *pxtty);
int  _cfunregparm0 wrapper_ttysettermios(void *tty, void *pxtty, int baud);
void _cfunregparm0 wrapper_ttyflushbuffer(void *tty, void *pxtty);


/*
 * Export functions for separate tty driver
 */
void pxdrv_ttydope(int *nttyp, int *major);
void *pxdrv_ttyopen(void *tty, int index, void (*insertflipchar)(void *tty, int c, int brkflag, int overrunflg));
void pxdrv_ttyclose(void *tty, void *pxtty);
int  pxdrv_ttywrite(void *tty, void *pxtty, const unsigned char *buffer, int count);
int  pxdrv_ttywriteroom(void *tty, void *pxtty);
int  pxdrv_ttycharsinbuffer(void *tty, void *pxtty);
int  pxdrv_ttysettermios(void *tty, void *pxtty, int baud);
void pxdrv_ttyflushbuffer(void *tty, void *pxtty);
