/*                                                                            
 *                                                                            
 *      pixcitty.c     External       5 SEPTEMBER 2012        
 *                                                                            
 *      Copyright (C)  2009-2012  EPIX, Inc.  Released under GPL. 
 *                                                                            
 *      Frame Grabber Driver: LINUX tty driver access to Camera Link serial   
 *                                                                            
 *      THIS IS A MACHINE GENERATED COPY                                      
 */                                                                           
#define PIXCI
#include <linux/version.h>
#include <linux/module.h>
#include <linux/param.h>
#include <linux/sched.h>
#include <linux/kernel.h>
#include <linux/delay.h>
#include <asm/uaccess.h>
#include <asm/current.h>
#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0))
  #include <asm/irq.h>
  #include <linux/interrupt.h>
  #if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,32))
    #include <linux/irqreturn.h>
  #endif
  #if !defined(UTS_RELEASE)
    #if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,35))
      #include <generated/utsrelease.h>
    #else
      #include <linux/utsrelease.h>
    #endif
  #endif
#else
  EXPORT_NO_SYMBOLS;
#endif
#if defined(PIXCI)
  #include "pixcipub.h"
  MODULE_AUTHOR("EPIX, Inc.");
  MODULE_DESCRIPTION("PIXCI(R) 32 Bit TTY Driver" ". " "3.7.00" " " "[12.09.05.110725]" ". ");
  MODULE_SUPPORTED_DEVICE("PIXCI(R) Imaging Boards");
  #if defined(MODULE_LICENSE)
    MODULE_LICENSE("GPL");
  #endif
#endif
#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0))
    #include <linux/tty.h>
    #include <linux/tty_driver.h>
    #include <linux/tty_flip.h>
    #include <asm/termios.h>
    struct tty_driver *pxdrv_tty = NULL;
    int pxdrv_ntty = 0;
#endif
#if (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,31))
static const char __module_depends[]
__used
__attribute__((section(".modinfo"))) =
"depends=""PIXCI(R)";
#elif (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0))
static const char __module_depends[]
__attribute_used__
__attribute__((section(".modinfo"))) =
"depends=""PIXCI(R)";
#endif
void cleanup_pxdrvttylnx(void)
{
    int i;
    if (pxdrv_tty != NULL) {
 for (i = 0; i < pxdrv_ntty; i++)
     tty_unregister_device(pxdrv_tty, i);
 tty_unregister_driver(pxdrv_tty);
    }
    if (1)
 printk("cleanup: " "PIXCI(R) 64 Bit Driver" " V" "3.7.00" "TTY \n");
}
int init_pxdrvttylnx(void)
{
    extern struct tty_operations pxdrvtty_ops;
    int r, major = 0;
    int ntty = 0;
    if (1)
 printk("init: " "PIXCI(R) 64 Bit Driver" " V" "3.7.00" "TTY " UTS_RELEASE " " "Sep  5 2012" " " "11:07:25" "\n");
    pxdrv_ttydope(&ntty, &major);
    if (ntty <= 0)
 return(-ENODEV);
    pxdrv_tty = alloc_tty_driver(ntty);
    if (!pxdrv_tty) {
 cleanup_pxdrvttylnx();
 return(-ENOMEM);
    }
    pxdrv_tty->owner = THIS_MODULE;
    pxdrv_tty->driver_name = "PIXCI(R) 64 Bit Driver" " V" "3.7.00";
    pxdrv_tty->name = "ttyPIXCI";
    pxdrv_tty->name_base = 0;
    pxdrv_tty->major = major;
    pxdrv_tty->minor_start = 256+1;
    pxdrv_tty->type = TTY_DRIVER_TYPE_SERIAL;
    pxdrv_tty->subtype = SERIAL_TYPE_NORMAL;
    #if defined(TTY_DRIVER_NO_DEVFS)
 pxdrv_tty->devfs_name = "tts/ttyPIXCI%d";
 pxdrv_tty->flags = TTY_DRIVER_REAL_RAW | TTY_DRIVER_NO_DEVFS;
    #else
 pxdrv_tty->flags = TTY_DRIVER_REAL_RAW | TTY_DRIVER_DYNAMIC_DEV;
    #endif
    pxdrv_tty->init_termios = tty_std_termios;
    pxdrv_tty->init_termios.c_cflag = B9600 | CS8 | CREAD | HUPCL | CLOCAL;
    tty_set_operations(pxdrv_tty, &pxdrvtty_ops);
    r = tty_register_driver(pxdrv_tty);
    if (r) {
 put_tty_driver(pxdrv_tty);
 return(r);
    }
    {
 int i;
 for (i = 0; i < ntty; i++)
     tty_register_device(pxdrv_tty, i, NULL);
    }
    pxdrv_ntty = ntty;
    return(0);
}
module_init(init_pxdrvttylnx);
module_exit(cleanup_pxdrvttylnx);
void pxdrvtty_insertflipchar(void *atty, int c, int brkflg, int overrunflg)
{
    struct tty_struct *tty = (struct tty_struct *)atty;
    if (!tty)
 return;
    #if defined(TTY_DRIVER_NO_DEVFS)
 if (tty->flip.count >= TTY_FLIPBUF_SIZE)
     tty_flip_buffer_push(tty);
    #else
 tty_buffer_request_room(tty, 1);
    #endif
    tty_insert_flip_char(tty, c, (brkflg?TTY_BREAK:0) | (overrunflg?TTY_OVERRUN:0) | ((!brkflg&!overrunflg)?TTY_NORMAL:0));
    tty_flip_buffer_push(tty);
}
int pxdrvtty_open(struct tty_struct *tty, struct file *file) {
    tty->driver_data = pxdrv_ttyopen(tty, tty->index, pxdrvtty_insertflipchar);
    if (!tty->driver_data)
 return(-ENODEV);
    tty->low_latency = 1;
    return(0);
}
void pxdrvtty_close(struct tty_struct *tty, struct file *file) {
    tty->closing = 1;
    tty->flags |= TTY_IO_ERROR;
    pxdrv_ttyclose(tty, tty->driver_data);
}
int pxdrvtty_write(struct tty_struct *tty, const unsigned char *buffer, int count) {
    if (!tty->driver_data)
 return(-ENODEV);
    return(pxdrv_ttywrite(tty, tty->driver_data, buffer, count));
}
int pxdrvtty_writeroom(struct tty_struct *tty) {
    if (!tty->driver_data)
 return(-ENODEV);
    return(pxdrv_ttywriteroom(tty, tty->driver_data));
}
int pxdrvtty_charsinbuffer(struct tty_struct *tty) {
    if (!tty->driver_data)
 return(-ENODEV);
    return(pxdrv_ttycharsinbuffer(tty, tty->driver_data));
}
#if (LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0))
void pxdrvtty_settermios(struct tty_struct *tty, struct termios *old)
#else
void pxdrvtty_settermios(struct tty_struct *tty, struct ktermios *old)
#endif
{
    if (!tty->driver_data)
 return;
    {
 int nbaud = pxdrv_ttysettermios(tty, tty->driver_data, tty_get_baud_rate(tty));
 int cflag = 0;
 switch (nbaud) {
   case 9600: cflag = B9600; break;
   case 19200: cflag = B19200; break;
   case 38400: cflag = B38400; break;
   case 57600: cflag = B57600; break;
   case 115200: cflag = B115200; break;
   case 230400: cflag = B230400; break;
   case 460800: cflag = B460800; break;
   case 921600: cflag = B921600; break;
 }
 if (cflag)
     tty->termios->c_cflag = cflag | CS8 | CREAD | HUPCL | CLOCAL;
    }
}
void pxdrvtty_flushbuffer(struct tty_struct *tty) {
    if (!tty->driver_data)
 return;
    pxdrv_ttyflushbuffer(tty, tty->driver_data);
}
struct tty_operations pxdrvtty_ops = {
    .open = pxdrvtty_open,
    .close = pxdrvtty_close,
    .write = pxdrvtty_write,
    .write_room = pxdrvtty_writeroom,
    .chars_in_buffer = pxdrvtty_charsinbuffer,
    .set_termios = pxdrvtty_settermios,
    .flush_buffer = pxdrvtty_flushbuffer,
};
