/************************************************************************/
/* espuiclient.h							*/
/*                                                                      */
/************************************************************************/
/*                                                                      */
/*     Center for High Angular Resolution Astronomy                     */
/* Georgia State University, Atlanta GA 30303-3083, U.S.A.              */
/*                                                                      */
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu/~theo/theo.html                  */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar (but mostly taken from espgtk)          */
/* Date   : May 2007                                                    */
/************************************************************************/

#ifndef __ESP_UI_CLIENT__
#define __ESP_UI_CLIENT__

#include <stdio.h>
#include <errno.h>

#define NUM_ESP_TYPES 9

extern char *esp_types[NUM_ESP_TYPES+1];
extern int ui_esp_servers[NUM_ESP_TYPES];

/* esp_messages.c */

int ui_open_esp_client(int argc, char **argv);
int call_close_esp_client(int argc, char **argv);
int call_send_esp_on(int argc, char **argv);
int call_send_esp_off(int argc, char **argv);
int call_send_esp_move_absolute(int argc, char **argv);
int call_send_esp_set_beam(int argc, char **argv);
int call_send_esp_set_velocity(int argc, char **argv);
int call_send_esp_set_acceleration(int argc, char **argv);
int call_send_esp_move_relative(int argc, char **argv);
int call_send_esp_move_home(int argc, char ** argv);
int call_send_esp_text(int argc, char ** argv);
int esp_fts(int argc, char **argv);
int show_esp_stage(int argc, char **argv);
int esp_get_axis(int argc, char ** argv);
int esp_get_server(int argc, char ** argv);
bool esp_get_server_and_axis(int argc, char ** argv, int *server, int *axis);

#endif
