/************************************************************************/
/* teststrehl.c								*/
/*									*/
/* Strehl to visibility calculation stuff.  				*/
/************************************************************************/

#include <zernike.h>

main(int argc, char **argv)
{
	float strehl;
	float logstrehl;
	float vis_tilt;
	float vis_no_tilt;
	float c_vis_tilt;
	float c_vis_no_tilt;
	int m;

	if (argc < 2)
	{
		fprintf(stderr,"usage: teststrehl m\n");
		exit(-1);
	}

	sscanf(argv[1],"%d",&m);

	set_up_zernike_calcs(21);

	printf("#            |-- with tilt ---|  |- without tilt -|\n");
	printf("#  Stehl     Direct    Cheb app  Direct    Cheb app\n");

	for(logstrehl = -3.0; strehl < 1.0 ; logstrehl += 0.1)
	{
		if ((strehl = pow(10.0,logstrehl)) > 1.0) strehl = 1.0;

		vis_tilt = zbrent_strehl_to_vis_tilt(strehl);
		vis_no_tilt = zbrent_strehl_to_vis_no_tilt(strehl);
		c_vis_tilt = cheb_strehl_to_vis_tilt(strehl,m);
		c_vis_no_tilt = cheb_strehl_to_vis_no_tilt(strehl,m);

		printf("%8.3f  %8.3f  %8.3f  %8.3f  %8.3f\n",strehl,
				vis_tilt,c_vis_tilt,
				vis_no_tilt,c_vis_no_tilt);
	}

	clean_up_zernike_calcs();

	exit(0);
}
