/************************************************************************/
/* testtt.c								*/
/*									*/
/* Tests tango/twiss calculation stuff.  				*/
/************************************************************************/

#include <zernike.h>

main()
{
	float dr0;
	float calc_dr0_tilt;
	float calc_dr0_no_tilt;
	float alpha;
	int    do_strehl;
	float result;
	float norm;
	float strehl_tilt;
	float strehl_no_tilt;
	float vis_tilt;
	float vis_no_tilt;

	set_up_zernike_calcs(21);

	printf("#   \tStrehl\tStrehl\tVisib\tVisib\n");
	printf("#D/R0\ttilt  \tNo tilt\ttilt\tNo tilt\tCalcDr0\tCalcDr0\n");

	for(dr0 = 0.0; dr0 < 10.0; dr0 += 0.1)
	{
		strehl_tilt = tango_twiss_strehl_tilt(dr0);
		strehl_no_tilt = tango_twiss_strehl_no_tilt(dr0);
		vis_tilt = tango_twiss_vis_tilt(dr0);
		vis_no_tilt = tango_twiss_vis_no_tilt(dr0);
		calc_dr0_tilt = zbrent_strehl_to_dr0_tilt(strehl_tilt);
		calc_dr0_no_tilt=zbrent_strehl_to_dr0_no_tilt(strehl_no_tilt);

		printf("%.2f\t%.4f\t%.4f\t%.4f\t%.4f\t%.2f\t%.2f\n",
			dr0,strehl_tilt,strehl_no_tilt,vis_tilt,vis_no_tilt,
			calc_dr0_tilt,calc_dr0_no_tilt);
	}

	clean_up_zernike_calcs();

	exit(0);
}
