/************************************************************************/
/* std_dalsa_functs.h							*/
/*                                                                      */
/* Standard functions in the Dalsa lib.  				*/
/************************************************************************/
/*                                                                      */
/*                    CHARA ARRAY USER INTERFACE			*/
/*                 Based on the SUSI User Interface			*/
/*		In turn based on the CHIP User interface		*/
/*                                                                      */
/*            Center for High Angular Resolution Astronomy              */
/*              Mount Wilson Observatory, CA 91001, USA			*/
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu			                */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar  		                        */
/* Date   : Jan 2000							*/
/************************************************************************/

#ifndef __STD_DALSA_FUNCTS__
#define __STD_DALSA_FUNCTS__
#endif
		{"ccd",		set_ccd},
		{"param",	call_set_params},
		{"p",		call_set_params},
		{"frame",	single_frame},
		{"fr",		single_frame},
		{"clear",	clear_window},
		{"clr",		clear_window},
		{"movie",	movie},
		{"mov",		movie},
		{"bgmovie",	background_movie},
		{"bgm",		background_movie},
		{"zbias",	zero_bias},
		{"cbias",	calculate_bias},
		{"dbias",	display_bias},
		{"fbias",	set_full_bias},
		{"bbias",	set_bb_bias},
		{"sbb",		call_set_bb},
		{"bb",		single_bb},
		{"bmovie",	bb_movie},
		{"bmov",	bb_movie},
		{"bbgmovie",	bb_background_movie},
		{"bbgm",	bb_background_movie},
		{"sdalsa",	show_dalsa_structure},
		{"frate",	measure_frame_rate},
		{"svf",		save_frame},
		{"svb",		save_bb},
                {"dps",         call_display_power_spec},
                {"cpsb",        power_spec_bias},
                {"tpsb",        toggle_ps_bias},
                {"spsz",        set_num_pix_zero},
                {"row",         set_spec_row},
                {"cflat",       data_flat},
                {"tflat",       toggle_data_flat},
                {"cdark",       calc_data_dark},
                {"tdark",       toggle_data_dark},
                {"tauto",       toggle_auto_range},
		{"ssc",		set_spect_cutoff},
