.TH filter_info 5 2004-May-03 CHARA "File formats"
.SH NAME
filter_info \- file with filter information lookup table
.SH DESCRIPTION
.B filter_info
is a text file that contains a lookup table of filter information for nsimpleX
routines.  The name and location are accessed by means of a shell variable,
.B NSIMPLEX_FILTER.
One would typically add the line:
.PP
export NSIMPLEX_FILTER=/ctrscrut/chara/etc/filter_info
.PP
to his or her bourne shell profile. Obviously, the path and name of the file
can be easily modified.

.PP

Within the file, there is one entry per line, and each line has the format:
.sp
.RS
filter description,,wavelength,,bandpass
.RE
.sp
The filter description is a free-form text string describing the filter.  The
only constraint is that it cannot have 2 commas in a row -- that combination is
used to parse the entry.  The wavelength and bandpass fields are numbers (in
microns) that represent the center wavelength and full-width, half maximum
values of the filter in question.  Comments in the file are denoted by the "#"
character -- anything to the right of this character is ignored by
.BR get_filter_value(3).

.SH AUTHOR
Nils Turner

.SH SEE ALSO
.BR get_filter_value(3),
.BR nsimpleX(3)
