/************************************************************************/
/* infoX.c 								*/
/*									*/
/* Prints info about the current X display 				*/
/* Part of the simpleX library.						*/
/************************************************************************/
/*                                        	                      	*/
/*     Center for High Angular Resolution Astronomy			*/
/* Georgia State University, Atlanta GA 30303-3083, U.S.A.		*/
/*									*/
/*									*/
/* Telephone: 1-404-651-1882						*/
/* Fax      : 1-404-651-1389						*/
/* email    : theo@chara.gsu.edu					*/
/* WWW	    : http://www.chara.gsu.edu/~theo/theo.html			*/
/*									*/
/* (C) This source code and its associated executable           	*/
/* program(s) are copyright.                                    	*/
/*                                                              	*/
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar						*/
/* Date   : August 1994   						*/
/************************************************************************/

#include <stdio.h>
#include "../nrc/nrc.h"
#include "nsimpleX.h"

/************************************************************************/
/* infoX()								*/
/*									*/
/* Prints out some information about the current X windows session.	*/
/************************************************************************/

void	infoX(void)
{
	printf("\nX Windows information:\n\n");
	printf("Display name      : %s\n",XDisplayName(NULL));
	printf("Vendor            : %s\n",ServerVendor(theDisplay));
	printf("Version Release   : %d\n",VendorRelease(theDisplay));
	printf("X version         : %d\n",ProtocolVersion(theDisplay));
	printf("X release         : %d\n",ProtocolRevision(theDisplay));
	printf("Color plane depth : %d\n",theDepth);
	printf("Color plane bytes : %d\n",theDepthBytes);
	printf("Bitmap padding    : %d\n",theBitmapPad);
	printf("Bitmap bytes      : %d\n",theBitmapBytes);
	printf("Display Width     : %d\n",theWidth);
	printf("Display Height    : %d\n",theHeight);
	

} /* infoX() */
