.TH nsimpleX 3 2004-May-06 CHARA nsimpleX CHARA
.SH NAME
nsimpleX
.SH SYNOPSIS
.nf
#include <nsimpleX.h>

.SH LIBS
.nf
-lnsimpleX -lnrc -lm -lX11

.fi
.SH DESCRIPTION

This is a set of very basic subroutines designed to take care of simple X
window display tasks such as 2D grey-scale images (with the ability to "point"
to a specific pixel with mouse), 2D line plots, and 2D "oscilloscope" plots (a
value vs. time 2D line plot where the newest data point comes in from the
right, pushing all previous data points to the left; the oldest (left-most)
data point in the window is dropped).  In addition to the X display and
manipulation routines, there are a number of routines for doing 2D image math
such as summing, subtracting, scaling, centroiding, smoothing, copying,
shifting, convolving, etc.  Also, there are routines for calculating and/or
building certain diffractive optics relationships.  Finally, there are routines
for saving the 2D image data to files (however, for maximum compatibility of
the saved image, it is recommended that 2D image data be saved as FITS files
using the "cfitsio" library).

As can be inferred from the "n" in "nsimpleX", it has a relationship to
"simpleX".  simpleX required an 8-bit (and 8-bit only) color display to
function properly.  nsimpleX has rearranged the information in the X calls so
that it functions properly on 8-, 16-, 24-, and 32-bit color displays.

.SH EXAMPLE

The best example of a working piece of code that demonstrates the
display depth independent way of calling the nsimpleX subroutines is
"test_airy.c".  For the RPM users, it is in the standard RPM doc tree -- type
"rpm -qd nsimpleX" to determine the local RPM doc tree location.

.SH AUTHOR
Theo ten Brummelaar

.SH SEE ALSO
.BR add_signal(3),
.BR airy_intensity(3),
.BR airyobsc_intensity(3),
.BR build_airy(3),
.BR calculate_fwhm(3),
.BR calculate_fwhp(3),
.BR calculate_ps(3),
.BR centroid_image(3),
.BR close_scope(3),
.BR convolve(3),
.BR copy_image(3),
.BR display_picture(3),
.BR filter_info(5),
.BR fit_1D_gaussian(3),
.BR fit_2D_gaussian(3),
.BR gassian_2D_func(3),
.BR gauss_1D_func(3),
.BR get_filter_value(3),
.BR get_mouse(3),
.BR infoX(3),
.BR initX(3),
.BR local_max_image_intensity(3),
.BR make_2D_gnuplot_file(3),
.BR make_ascii_pict(3),
.BR make_picture(3),
.BR make_ppm_P3(3),
.BR make_ppm_P6(3),
.BR max_image_intensity(3),
.BR merge_plots(3),
.BR min_image_intensity(3),
.BR normalize_image(3),
.BR openWindow(3),
.BR open_scope(3),
.BR overlay_line(3),
.BR overlay_rectangle(3),
.BR plot_funct(3),
.BR quitX(3),
.BR scale_image(3),
.BR shift_matrix(3),
.BR smooth_image(3),
.BR subtract_images(3),
.BR sum_images(3),
.BR total_image(3),
.BR update_scope(3),
.BR zero_edge(3)
