/************************************************************************/
/* quitx.c								*/
/*									*/
/* Closes down display for X windows 					*/
/* Part of the simpleX library.						*/
/************************************************************************/
/*                                                                      */
/*     Center for High Angular Resolution Astronomy                     */
/* Georgia State University, Atlanta GA 30303-3083, U.S.A.              */
/*                                                                      */
/*                                                                      */
/* Telephone: 1-404-651-1882                                            */
/* Fax      : 1-404-651-1389                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu/~theo/theo.html                  */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar						*/
/* Date   : August 1994   						*/
/************************************************************************/

#include <stdio.h>
#include "../nrc/nrc.h"
#include "nsimpleX.h"

/************************************************************************/
/* quitX()								*/
/*									*/
/* Closes the nsimpleX "X windows" session.				*/
/************************************************************************/

void quitX(void)
{
	if (!display_is_open) return;
	XCloseDisplay(theDisplay);
	display_is_open = FALSE;

} /* quitX() */
