/************************************************************************/
/* opleft.h								*/
/*                                                                      */
/* Header file for OPLE fringe tracking control library.		*/
/************************************************************************/
/*                                                                      */
/*                    CHARA ARRAY USER INTERFACE			*/
/*                 Based on the SUSI User Interface			*/
/*		In turn based on the CHIP User interface		*/
/*                                                                      */
/*            Center for High Angular Resolution Astronomy              */
/*              Mount Wilson Observatory, CA 91001, USA			*/
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu			                */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar 		                        */
/* Date   : March 2010							*/
/************************************************************************/

#ifndef __OPLEFT__
#define __OPLEFT__

#ifndef NUM_DELAY_LINES
#define NUM_DELAY_LINES	6
#endif

#ifndef LASER_SIGN

/* So lengths make sense */

#define LASER_SIGN -1                           

/* Info about the metrology */

#define NUM_LASER_PASSES 4.0 /* How many times laser goes through optics */
#define NUM_LASER_TICKS  256.0 /* How many ticks per wavelength */

/*
 * The following is a bit of a cludge as it hardwires the
 * laser wavelength. Never the less it helps in the display of
 * position information. It also does not take into account the
 * refractive index of the air. However this way a human can understand
 * the displayed numbers in the status screen.
 */

#define LASER_TO_METERS  (1.319e-6/(NUM_LASER_PASSES*NUM_LASER_TICKS))
#endif

int open_ople_fringe_tracking_socket(void);
void close_ople_fringe_tracking_socket(void);
void current_fringe_tracking_targets(double targets[6]);
int set_fringe_tracking_targets(double targets[6]);
int incriment_fringe_tracking_targets(double targets[6]);
int send_fringe_tracking_targets(void);
#endif
