/************************************************************************/
/* popclient.h								*/
/*                                                                      */
/* General Header File.							*/
/* Mostly coppies from Dave Berger's code.				*/
/************************************************************************/
/*                                                                      */
/*                    CHARA ARRAY CLIENT/SERVER				*/
/*                 Based on the CHARA User Interface			*/
/*                 Based on the SUSI User Interface			*/
/*		In turn based on the CHIP User interface		*/
/*                                                                      */
/*            Center for High Angular Resolution Astronomy              */
/*              Mount Wilson Observatory, CA 91001, USA			*/
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@@chara.gsu.edu                                       */
/* WWW      : http://www.chara.gsu.edu			                */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar                          		*/
/* Date   : Oct 2007							*/
/************************************************************************/

#ifndef __POPCLIENT__
#define __POPCLIENT__

#define N_POPS	24

/* status bits */

#define STATUS_LIMIT_NONE	0x0
#define STATUS_LIMIT_FWD	0x1
#define STATUS_LIMIT_REV	0x2
#define STATUS_LIMIT_BOTH	0x3

#define STATUS_MOTOR_OFF	0x0
#define STATUS_MOTOR_FWD	0x1
#define STATUS_MOTOR_REV	0x2

#define STATUS_LED_OFF		0x0
#define STATUS_LED_RED		0x1
#define STATUS_LED_GREEN	0x2
#define STATUS_LED_YELLOW	0x3

/* Globals */

extern struct POP pops[N_POPS];
extern int pop_server;

/* pop_client.c */

int open_pop_client(void);
void close_pop_client(void);
int message_pop_server_stopping(int server, struct smessage *mess);
int message_pop_status(int server, struct smessage *mess);
int get_pop_status(int id);
int get_all_pop_status(void);
int send_pop_in(int id);
int send_pop_out(int id);
int send_pop_off(int id);
int send_pop_led_red(int id);
int send_pop_led_green(int id);
int send_pop_led_yellow(int id);
int send_pop_led_off(int id);

#endif
