/************************************************************************/
/* std_pop_functs.h							*/
/*                                                                      */
/* List of standard functions to be included in any functs.c file.  	*/
/************************************************************************/
/*                                                                      */
/*                    CHARA ARRAY USER INTERFACE			*/
/*                 Based on the SUSI User Interface			*/
/*		In turn based on the CHIP User interface		*/
/*                                                                      */
/*            Center for High Angular Resolution Astronomy              */
/*              Mount Wilson Observatory, CA 91001, USA			*/
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu			                */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Tony Johnson & Theo ten Brummelaar                          */
/* Date   : Original Version 1990 - ported to Linux 1998                */
/************************************************************************/

#ifndef __STD_POP_FUNCTS__
#define __STD_POP_FUNCTS__
		{"popo",	call_open_pop_client},
		{"popc",	call_close_pop_client},
		{"popin",	call_send_pop_in},
		{"popout",	call_send_pop_out},
		{"popoff",	call_send_pop_off},
		{"popred",	call_send_pop_led_red},
		{"popgreen",	call_send_pop_led_green},
		{"popgrn",	call_send_pop_led_green},
		{"popledon",	call_send_pop_led_green},
		{"poplon",	call_send_pop_led_green},
		{"popyellow",	call_send_pop_led_yellow},
		{"popyel",	call_send_pop_led_yellow},
		{"popledoff",	call_send_pop_led_off},
		{"poploff",	call_send_pop_led_off},
		{"popupdate",	call_get_all_pop_status},
		{"popstatus",	show_pop_status},
		{"popstat",	show_pop_status},
		{"popsummary",	show_pop_summary},
		{"popsum",	show_pop_summary},
#endif
