/************************************************************************/
/* classicheader.c							*/
/*									*/
/* Program to read and print CLASSIC data file header.			*/
/************************************************************************/
/*                                                                      */
/*     Center for High Angular Resolution Astronomy                     */
/* Georgia State University, Atlanta GA 30303-3083, U.S.A.              */
/*                                                                      */
/*                                                                      */
/* Telephone: 1-404-651-1882                                            */
/* Fax      : 1-404-651-1389                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu/~theo/theo.html                  */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar						*/
/* Date   : December 2006   						*/
/************************************************************************/

#include <stdio.h>
#include "../charalib/chara.h"

int main(int argc, char **argv)
{
	struct s_classic_header	header;

	if (argc != 2)
	{
		fprintf(stderr,"Usage: %s filename.fit.\n", argv[0]);
		exit(-1);
	}

	if (read_classic_header(argv[1], &header) != 0)
	{
		fprintf(stderr,"Failed to open file %s\n", argv[1]);
		exit(-2);
	}

	print_classic_header(stdout, header);

	exit(0);
}
