/************************************************************************/
/* picom.c								*/
/*                                                                      */
/* Main routine for the picomotor control. 				*/
/* THIS PROGRAM NOW OBSOLETE.						*/
/************************************************************************/
/*                                                                      */
/*                    CHARA ARRAY USER INTERFACE			*/
/*                 Based on the SUSI User Interface			*/
/*		In turn based on the CHIP User interface		*/
/*                                                                      */
/*            Center for High Angular Resolution Astronomy              */
/*              Mount Wilson Observatory, CA 91001, USA			*/
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu			                */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar			                        */
/* Date   : Fri Aug 11 10:24:13 PDT 2000				*/
/************************************************************************/

#define FUNCTS
#include "../charaui/src/charaui.h"
#undef FUNCTS
#include "../pico/picom.h"

/* Prototypes */

void picom_close(void) {pico_port_close(0, NULL); }
int test_control_motor(int argc, char **argv);
void setup_background_jobs(void);
int linux_time_status(void);

/* Commands */

struct {                       
                char    *name;
                int     (*function)(int argc, char **argv);
        } functions[] = 

	{	
		/* Standard Function Set */

		{NULL,		NULL},
#include "../charaui/src/std_ui_functs.h"

		/* Picom Function Set */

#include "../pico/std_picom_functs.h"

		/* Local test functions */

		{"mc", test_control_motor},
                {NULL,          NULL}   };

int main(int argc, char **argv)
{
	/* Title page. */

	ui_clear_screen();
	put_line("");
	center_line("PICOMOTOR CONTROL 1.0");
	put_line("");
	center_line("The CHARA Array");
	center_line("Center for High Angular Resolution Astronomy");
	center_line("Mount Wilson Observatory, CA 91001, USA");
	put_line("");
	center_line("Telephone: 1-626-796-5405");
	center_line("Fax: 1-626-796-6717");
	center_line("email: theo@chara.gsu.edu");
	center_line("WWW: http://www.mtwilson.edu");
	put_line("");
	center_line("(C) This executable program is copyright.");
	wait_for_title();


	/* Initialize the user interface */

	TITLE = "NF8732 1.0";
	initialise_ui("picom_menus.ini", "picom_help.ini", "pico");

	/* Setup background job(s) */

	setup_background_jobs();

	/* Set up to close things out */

	set_user_close_function(picom_close);

	/* Let's go! */

	start_ui(); /* Should never return from here. */

	exit(0);

} /* main() */

/*
 * TEST ROUTINE FOR NOW ONLY 
 * This has now, mostly, been moved to wobble_detect.
 */

char *names[] =   {"S1B  ",	"S2B  ",	"S1M10",	"S2M10", 
		   "S1MT2",	"S2MT2",	"S1/S2",	"S1/E1", 
		   "E1M10",	"E2M10",	"S1MT1",	"S2MT1",
		   "E1MT1",	"E1MT2",	"TEST",		NULL};

int  types[] =    {UNCOUPLED,	UNCOUPLED,	COUPLED, 	COUPLED, 
    		   UNCOUPLED,	UNCOUPLED,	SINGLE,  	SINGLE, 
		   COUPLED,  	COUPLED,  	UNCOUPLED,	UNCOUPLED,
		   UNCOUPLED,	UNCOUPLED,	COUPLED};

int  axis_one[] = {112,    	122,   	  	132,     	142,
		   212,    	222,   	  	232,     	242,
		   312,    	322,	     	332,		342,
		   412,		422,		511};

int  axis_two[] = {113,    	123,      	133,     	143,
		   213,    	223,      	000,     	000,
		   313,    	323,      	333,		343,
		   413,		423,		512};

int  pulses[]   = { 25,         25,             25,             25,
                     5,          5,             50,             50,
                    25,         25,              5,              5,
                     5,          5,		50};

int test_control_motor(int argc, char **argv)
{

	if (argc > 1)
		return control_mirror(argv[1],pulses,names,
			types,axis_one,axis_two);
	else
		return control_mirror(NULL,pulses,names,
			types,axis_one,axis_two);

}

/************************************************************************/
/* setup_background_jobs()						*/
/*									*/
/* Guess what this does.						*/
/************************************************************************/

void setup_background_jobs(void)
{
        background_add(linux_time_status);

} /* setup_background_jobs() */

/************************************************************************/
/* linux_time_status()							*/
/* 									*/
/* Displays the linux system time in the status window.			*/
/************************************************************************/

int linux_time_status(void)
{
	time_t current_time;
	struct tm *now;

	time(&current_time);
	now = localtime(&current_time);
	wstandout(status_window);
	mvwaddstr(status_window,0,0,"Local Tm: ");
	wstandend(status_window);
	wprintw(status_window,"    %2d:%02d",
		now->tm_hour,now->tm_min);

	return NOERROR;

} /* linux_time_status() */
