/************************************************************************/
/* printconfig.c							*/
/*									*/
/* Spits out current configuration data.				*/
/*									*/
/************************************************************************/
/*                                                                      */
/*     Center for High Angular Resolution Astronomy                     */
/* Georgia State University, Atlanta GA 30303-3083, U.S.A.              */
/*                                                                      */
/*                                                                      */
/* Telephone: 1-404-651-1882                                            */
/* Fax      : 1-404-651-1389                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu/~theo/theo.html                  */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*									*/
/* Author: Theo								*/
/* Date: April 2007							*/
/*									*/
/************************************************************************/

#include "../cliserv/include/cliserv.h"
#include "../charalib/chara.h"
#include "../astromod/astromod.h"
#include <stdlib.h>
#include <stdio.h>

int main(int argc, char **argv)
{
	FILE	*fp;

	/* Is there a file name? */

	if (argc > 1)
	{
		if ((fp = fopen(argv[1], "w")) == NULL)
		{
			fprintf(stderr, "Failed to open file %s\n", argv[1]);
			exit(-1);
		}
	}
	else
	{
		fp = stdout;
	}

	/* Read in the juicy stuff */

	astromod_init(NULL, NULL);

	print_chara_config(fp);

	/* That is all */

	if (fp != stdout) fclose(fp);

	exit(0);

}
