/************************************************************************/
/* scintialltion.c 							*/
/*									*/
/* Spit out example piston error vectors.				*/
/************************************************************************/
/*                                                                      */
/*     Center for High Angular Resolution Astronomy                     */
/* Georgia State University, Atlanta GA 30303-3083, U.S.A.              */
/*                                                                      */
/*                                                                      */
/* Telephone: 1-404-651-1882                                            */
/* Fax      : 1-404-651-1389                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu/~theo/theo.html                  */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar						*/
/* Date   : April 2010   						*/
/************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include "../nrc/nrc.h"
#include "../interferometry/interferometry.h"

int main(int argc, char **argv)
{
	int	i;
	float	*scint;
	float 	f0, dt;
	int	n;

	if (argc != 4)
	{
		fprintf(stderr,"Usage: %s f0(Hz) dt(s) n\n", argv[0]);
		exit(-1);
	}

	sscanf(argv[1], "%f", &f0);
	sscanf(argv[2], "%f", &dt);
	sscanf(argv[3], "%d", &n);

	scint = scintillation(f0, dt, n);

	for(i=1; i<=n ;i++) printf("%.4f\n", scint[i]);

	free_vector(scint,1,n);

	exit(0);

}
