/************************************************************************/
/* strcmpi.c								*/
/*									*/
/* This is exactly like the normal strcmp() function but case 		*/
/* insensetive. It is a patch for Unix as it does not normally exeist.	*/
/************************************************************************/
/*                                                                      */
/*                    CHARA ARRAY USER INTERFACE			*/
/*                 Based on the SUSI User Interface			*/
/*		In turn based on the CHIP User interface		*/
/*                                                                      */
/*            Center for High Angular Resolution Astronomy              */
/*              Mount Wilson Observatory, CA 91001, USA			*/
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu			                */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Tony Johnson & Theo ten Brummelaar                          */
/* Date   : Original Version 1990 - ported to Linux 1998                */
/************************************************************************/

#include <stdio.h>

/************************************************************************/
/* strcmpi()								*/
/*									*/
/* Compares two strings. Returns 0 if they are the same, -1 if the	*/
/* second string is greater than the first or +1 if the first is	*/
/* greater than the second.						*/
/*									*/
/* This function is NOT case sensitive.					*/
/*									*/
/************************************************************************/

int	strcmpi(char *string1, char *string2)
{
	int i;		/* Looping integer */
	int	     result;	/* Return value */

	for ( i = 0; string1[i] == string2[i] 
		     || string1[i] == string2[i]-'a'+'A'
		     || string1[i] == string2[i]+'a'-'A' ; i++)
	{
		if (string1[i] == (char)NULL) return 0;
	}

	result = string1[i] - string2[i];

	if (result < 0) 
	{
		return -1;
	}
	else 
	{
		return 1;
	}

}	/* strcmpi() */	
