/************************************************************************/
/* testdir.c 								*/
/*									*/
/* Tests the routines to construct standard file names.			*/
/************************************************************************/
/*                                                                      */
/*     Center for High Angular Resolution Astronomy                     */
/* Georgia State University, Atlanta GA 30303-3083, U.S.A.              */
/*                                                                      */
/*                                                                      */
/* Telephone: 1-404-651-1882                                            */
/* Fax      : 1-404-651-1389                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu/~theo/theo.html                  */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar						*/
/* Date   : August 1994   						*/
/************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "../charalib/chara.h"

int main(int argc, char **argv)
{
	char	s[2048];

	printf("Base directory        : %s\n",get_base_directory(s));
	printf("Etc directory         : %s\n",get_etc_directory(s));
	printf("Data directory        : %s\n",get_data_directory(s));
	printf("Pict directory        : %s\n",get_pict_directory(s));
	printf("Scope data file       : %s\n",get_telescope_data_file(s));
	printf("Scope origin log      : %s\n",get_telescope_origin_log_file(s));
	printf("Environ file          : %s\n",get_environ_file(s));
	printf("Star data file        : %s\n",get_star_data_file(s));
	printf("Abriged star data file: %s\n",get_abrig_star_data_file(s));
	printf("System data file      : %s\n",get_system_data_file(s));
	printf("Socket manager file   : %s\n",get_socket_manager_file(s));

	exit(0);
}

