/************************************************************************/
/* testsao.c  	                                                       */
/*                                                                      */
/* Test star data reading routines.					*/
/************************************************************************/
/*                                                                      */
/*     Center for High Angular Resolution Astronomy                     */
/* Georgia State University, Atlanta GA 30303-3083, U.S.A.              */
/*                                                                      */
/*                                                                      */
/* Telephone: 1-404-651-1882                                            */
/* Fax      : 1-404-651-1389                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu/~theo/theo.html                  */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo		                                        */
/* Date   : March 2003                                                  */
/************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "../charalib/chara.h"

int main(int argc, char **argv)
{
	STAR_DATA star;
	int	sao;

	if (argc != 2)
	{
		fprintf(stderr,"usage: %s sao#\n", argv[0]);
		exit(-1);
	}
	sscanf(argv[1],"%d",&sao);

	if (get_star_by_sao(sao, &star))
	{
		printf("Name\t%s\n",star.name);
		printf("Number\t%d\n",star.chara_number);
                printf("IRC\t%s\n",star.irc);
		printf("HR\t%s\n",star.hr);
		printf("HD\t%s\n",star.hd);
		printf("SAO\t%s\n",star.sao);
		printf("FK5\t%s\n",star.fk5);
		printf("HIP\t%s\n",star.hip);
		printf("GJ\t%s\n",star.gj);
		printf("2MASS\t%s\n",star.twomass);
		printf("RA\t%s (%f)\n",star.rastr, star.ra);
		printf("DEC\t%s (%f)\n",star.decstr, star.dec);
		printf("PM_RA\t%e\n",star.pm_ra);
		printf("PM_DEC\t%e\n",star.pm_dec);
		printf("PAR\t%f\n",star.parallax);
		printf("RADVEL\t%f\n",star.radvel);
		printf("VMAG\t%f\n",star.vmag);
		printf("KMAG\t%f\n",star.kmag);
		printf("TYPE\t%s\n",star.spectype);
	}
	else
		printf("Not found.\n");

	exit(0);
}
