/************************************************************************/
/* v4l2.h								*/
/*                                                                      */
/* FUnctions to talk to the video for linux version 2 interface.	*/
/************************************************************************/
/*                                                                      */
/*                    CHARA ARRAY USER INTERFACE			*/
/*                 Based on the SUSI User Interface			*/
/*		In turn based on the CHIP User interface		*/
/*                                                                      */
/*            Center for High Angular Resolution Astronomy              */
/*              Mount Wilson Observatory, CA 91001, USA			*/
/*                                                                      */
/* Telephone: 1-626-796-5405                                            */
/* Fax      : 1-626-796-6717                                            */
/* email    : theo@chara.gsu.edu                                        */
/* WWW      : http://www.chara.gsu.edu			                */
/*                                                                      */
/* (C) This source code and its associated executable                   */
/* program(s) are copyright.                                            */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/* Author : Theo ten Brummelaar         		                */
/* Date   : Nov 2009 							*/
/************************************************************************/

#ifndef __V4L2__
#define __V4L2__

int v4l2_initialize(char *device, int num_tv_buffers, int cols, int rows);
int v4l2_current_brightness(int fd);
int v4l2_current_contrast(int fd);
int v4l2_stop(int fd);
void *v4l2_get_frame(int fd);
int v4l2_set_brightness(int fd, long int brightness);
int v4l2_set_contrast(int fd, long int contrast);
char *v4l2_errmess(void);

#endif
